#include <linux/kernel.h>
#include "sis_301.h"

BOOLEAN SiSSetCRT2Group(USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo,
			PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT temp;

	SiSSetFlag=SiSSetFlag|ProgrammingCRT2;
	SiSSearchModeID(ROMAddr,ModeNo);

	temp=SiSGetRatePtrCRT2(ROMAddr,ModeNo);
	if (((temp&0x02)==0) && ((SiSVBInfo&CRT2DisplayFlag)==0))
		return(FALSE);
	SiSSaveCRT2Info(ModeNo);
	SiSDisableBridge(BaseAddr);   
	SiSUnLockCRT2(BaseAddr);
	SiSSetDefCRT2ExtRegs(BaseAddr);    
	SiSSetCRT2ModeRegs(BaseAddr,ModeNo);   
	if (SIS_IF_DEF_LVDS==0) {
		if (SiSVBInfo&CRT2DisplayFlag) {
			SiSLockCRT2(BaseAddr);
			return 0;
		}
	}
	SiSGetCRT2Data(ROMAddr,ModeNo); 
	if (SIS_IF_DEF_LVDS==1) {
		SiSGetLVDSDesData(ROMAddr,ModeNo);  
	}
	SiSSetGroup1(BaseAddr,ROMAddr,ModeNo,HwDeviceExtension);
	if (SIS_IF_DEF_LVDS==0) {
		SiSSetGroup2(BaseAddr,ROMAddr);		
		SiSSetGroup3(BaseAddr,ROMAddr);
		SiSSetGroup4(BaseAddr,ROMAddr,ModeNo);
		SiSSetGroup5(BaseAddr,ROMAddr);
	}
	else {
		if (SIS_IF_DEF_CH7005==1) SiSSetCHTVReg(ROMAddr,ModeNo);   
		SiSModCRT1CRTC(ROMAddr,ModeNo);   
		SiSSetCRT2ECLK(ROMAddr,ModeNo);
	}
	SiSEnableCRT2();
	SiSEnableBridge(BaseAddr);
	if (SIS_IF_DEF_LVDS==0) {
	/* SiSSetLockRegs();  */
	}
	SiSLockCRT2(BaseAddr);
	return 1;
}

VOID SiSSetDefCRT2ExtRegs(USHORT BaseAddr)
{
	USHORT  Part1Port,Part2Port,Part4Port;
	USHORT  temp;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	if (SIS_IF_DEF_LVDS==0) {
		SiSSetReg1(Part1Port,0x02,0x40);
		SiSSetReg1(Part4Port,0x10,0x80);
		temp=(UCHAR)SiSGetReg1(SiSP3c4,0x16);
		temp=temp&0xC3;
		SiSSetReg1(SiSP3d4,0x35,temp);
	}
	else {
		SiSSetReg1(SiSP3d4,0x32,0x02);
		SiSSetReg1(Part1Port,0x02,0x00);
	}
}

USHORT SiSGetRatePtrCRT2(ULONG ROMAddr, USHORT ModeNo)
{                           /* return bit0=>0:standard mode 1:extended mode */
	SHORT  index;           /*        bit1=>0:crt2 no support this mode     */
	USHORT temp;            /*              1:crt2 support this mode        */
	USHORT ulRefIndexLength;
	USHORT temp1,modeflag1,Flag;
	SHORT  LCDRefreshIndex[2]={0x03,0x01};

	if (SIS_IF_DEF_CH7005==1) {
		if (SiSVBInfo&SetCRT2ToTV) {
			modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
			if (modeflag1&HalfDCLK) return(0);
		}
	}
	if (ModeNo<0x14) return(0);       /* Mode No <= 13h then return              */

	index=SiSGetReg1(SiSP3d4,0x33);        /* Get 3d4 CRTC33                          */
	index=index>>SelectCRT2Rate;     /* For CRT2,cl=SelectCRT2Rate=4, shr ah,cl */
	index=index&0x0F;                /* Frame rate index                        */
	if (index!=0) index--;

	if (SiSSetFlag&ProgrammingCRT2) {
		Flag=1;
		if (SIS_IF_DEF_CH7005==1) {
			if (SiSVBInfo&SetCRT2ToTV) {
				index=0;
				Flag=0;
			}
		}
		if ((Flag)&&(SiSVBInfo&SetCRT2ToLCD)) {
			if (SIS_IF_DEF_LVDS==0) {
				temp=SiSLCDResInfo;
				temp1=LCDRefreshIndex[temp];
				if (index>temp1) {
					index=temp1;
				}
			}
			else {
				index=0;
			}
		}
	}

	SiSREFIndex=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x04));   /* si+Ext_point */

	ulRefIndexLength =Ext2StructSize;
	do {
		temp=*((USHORT *)(ROMAddr+SiSREFIndex));              /* di => SiSREFIndex */
		if (temp==0xFFFF) break;
		temp=temp&ModeInfoFlag;
		if (temp<SiSModeType) break;

		SiSREFIndex=SiSREFIndex+ulRefIndexLength;                /* rate size */
		index--;
		if (index<0) {
			if (!(SiSVBInfo&SetCRT2ToRAMDAC)) {
        		if (SiSVBInfo&SetInSlaveMode) {
					temp1=*((USHORT *)(ROMAddr+SiSREFIndex+0-Ext2StructSize));
					if (temp1&InterlaceMode) {
						index=0;
					}
				}
			}
		}
	} while(index>=0);
	SiSREFIndex=SiSREFIndex-ulRefIndexLength;                    /* rate size */

	if ((SiSSetFlag&ProgrammingCRT2)) {
		temp1=SiSAjustCRT2Rate(ROMAddr);
	} else {
		temp1=0;
	}
	
	return(0x01|(temp1<<1));
}
	
BOOLEAN SiSAjustCRT2Rate(ULONG ROMAddr)
{
	USHORT tempax,tempbx=0,temp,resinfo;
	USHORT tempextinfoflag,Flag;
	tempax=0;
	if (SIS_IF_DEF_LVDS==0) {
		if (SiSVBInfo&SetCRT2ToRAMDAC) {
			tempax=tempax|SupportRAMDAC2;
		}
		if (SiSVBInfo&SetCRT2ToLCD) {
			tempax=tempax|SupportLCD;
			if (SiSLCDResInfo!=Panel1280x1024) {
				temp=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x09)); /* si+Ext_ResInfo */
				if (temp>=9) tempax=0;
			}
		}
		if (SIS_IF_DEF_HiVision==1) {
			tempax=tempax|SupportHiVisionTV;
			if (SiSVBInfo&SetInSlaveMode) {
				resinfo=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x09)); /* si+Ext_ResInfo  */
				if (resinfo==4) return(0);
				if (resinfo==3) {
					if (SiSSetFlag&TVSimuMode) return(0);
				}
				if (resinfo>7) return(0);
			}
		}
		else {
			if (SiSVBInfo&(SetCRT2ToAVIDEO|SetCRT2ToSVIDEO|SetCRT2ToSCART)) {
				tempax=tempax|SupportTV;
				if (!(SiSVBInfo&SetPALTV)) {
					tempextinfoflag=*((USHORT *)(ROMAddr+SiSREFIndex+0x0)); /* di+Ext_InfoFlag */
					if (tempextinfoflag&NoSupportSimuTV) {
						if (SiSVBInfo&SetInSlaveMode) {
							if (!(SiSVBInfo&SetNotSimuMode)) {
								return 0;
							}
						}
					}
				}
			}
		}

		tempbx=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x04));   /* si+Ext_point */
	}
	else {  /* for LVDS */
		Flag=1;
		if (SIS_IF_DEF_CH7005==1) {
			if (SiSVBInfo&SetCRT2ToTV) {
				tempax=tempax|SupportCHTV;
				Flag=0;
			}
		}                    
		tempbx=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x04));   
		if ((Flag)&&(SiSVBInfo&SetCRT2ToLCD)) {
			tempax=tempax|SupportLCD;
			temp=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x09)); /* si+Ext_ResInfo  */
			if (temp>0x08)   return(0);       /* 1024x768  */
			if (SiSLCDResInfo<Panel1024x768) {
				if (temp>0x07) return(0);       /* 800x600  */
				if (temp==0x04) return(0);      /* 512x384  */
			}
		}
	}
	for(;SiSREFIndex>tempbx;SiSREFIndex-=Ext2StructSize) {
		tempextinfoflag=*((USHORT *)(ROMAddr+SiSREFIndex+0x0)); /* di+Ext_InfoFlag */
		if (tempextinfoflag&tempax) {
			return 1;
		}
	}
	for(SiSREFIndex=tempbx;;SiSREFIndex+=Ext2StructSize) {
		tempextinfoflag=*((USHORT *)(ROMAddr+SiSREFIndex+0x0)); /* di+Ext_InfoFlag */
		if (tempextinfoflag==0x0FFFF) {
			return 0;
		}
		if (tempextinfoflag&tempax) {
			return 1;
		}
	}
	return(FALSE);
}

VOID SiSSaveCRT2Info(USHORT ModeNo)
{
	USHORT temp1,temp2,temp3;
	temp1=(SiSVBInfo&SetInSlaveMode)>>8;
	temp2=~(SetInSlaveMode>>8);
	temp3=(UCHAR)SiSGetReg1(SiSP3d4,0x31);
	temp3=((temp3&temp2)|temp1);
	SiSSetReg1(SiSP3d4,0x31,(USHORT)temp3);
	temp3=(UCHAR)SiSGetReg1(SiSP3d4,0x35);
	temp3=temp3&0xF3;
	SiSSetReg1(SiSP3d4,0x35,(USHORT)temp3);
}

VOID SiSDisableLockRegs() {
	UCHAR temp3;
	temp3=(UCHAR)SiSGetReg1(SiSP3c4,0x32);
	temp3=temp3&0xDF;
	SiSSetReg1(SiSP3c4,0x32,(USHORT)temp3);
}

VOID SiSDisableCRT2() {
	UCHAR temp3;
	temp3=(UCHAR)SiSGetReg1(SiSP3c4,0x1E);
	temp3=temp3&0xDF;
	SiSSetReg1(SiSP3c4,0x1E,(USHORT)temp3);
}

VOID SiSDisableBridge(USHORT  BaseAddr)
{
	UCHAR   temp3,part2_02,part2_05;
	USHORT  Part2Port,Part1Port=0;
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;

	if (SIS_IF_DEF_LVDS==0) {
		part2_02=(UCHAR)SiSGetReg1(Part2Port,0x02);
		part2_05=(UCHAR)SiSGetReg1(Part2Port,0x05);
		/* if (!SiSWaitVBRetrace(BaseAddr)) */         /* return 0:no enable read dram */
		{
			SiSLongWait();
			SiSDisableLockRegs();
		}
		SiSSetReg1(Part2Port,0x02,0x38);
		SiSSetReg1(Part2Port,0x05,0xFF);
		temp3=(UCHAR)SiSGetReg1(Part2Port,0x00);
		temp3=temp3&0xDF;
		SiSSetReg1(Part2Port,0x00,(USHORT)temp3);
		SiSSetReg1(Part2Port,0x02,part2_02);
		SiSSetReg1(Part2Port,0x05,part2_05);
		SiSDisableCRT2();
	}
	else {
		SiSDisableLockRegs();
		SiSDisableCRT2();
		SiSUnLockCRT2(BaseAddr);
		SiSSetRegANDOR(Part1Port,0x02,0xFF,0x40); /* et Part1Port ,index 2, D6=1,  */
	}
}

VOID SiSGetCRT2Data(ULONG ROMAddr,USHORT ModeNo)
{
	if (SIS_IF_DEF_LVDS==0) { /* 301  */
		SiSGetCRT2Data301(ROMAddr,ModeNo);
		return;
	} else { /* LVDS */
		SiSGetCRT2DataLVDS(ROMAddr,ModeNo);
		return;
	}
}

VOID SiSGetCRT2DataLVDS(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempax,tempbx,OldREFIndex;  

	OldREFIndex=(USHORT)SiSREFIndex;         /* push di  */
	SiSGetResInfo(ROMAddr,ModeNo);
	SiSGetCRT2Ptr(ROMAddr,ModeNo);

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex));
	tempax=tempax&0x0FFF;
	SiSVGAHT=tempax;

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+1));
	tempax=tempax>>4;
	tempax=tempax&0x07FF;
	SiSVGAVT=tempax;

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+3));
	tempax=tempax&0x0FFF;
	tempbx=*((USHORT *)(ROMAddr+SiSREFIndex+4));
	tempbx=tempbx>>4;
	tempbx=tempbx&0x07FF;

	SiSHT=tempax;
	SiSVT=tempbx;

	if (SIS_IF_DEF_TRUMPION==0) {
		if (SiSVBInfo&SetCRT2ToLCD) {
			if (!(SiSLCDInfo&LCDNonExpanding)) {
				if (SiSLCDResInfo==Panel800x600) {
					tempax=800;
					tempbx=600;
				} else if (SiSLCDResInfo==Panel1024x768) { 
					tempax=1024;
					tempbx=768;
				} else {
					tempax=1280;
					tempbx=1024;
				} 
				SiSHDE=tempax;
				SiSVDE=tempbx;
			}
		}
	}
	SiSREFIndex=OldREFIndex;         /* pop di  */
	return;
}

VOID SiSGetCRT2Data301(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempax,tempbx,modeflag1,OldREFIndex;
	USHORT tempal,tempah,tempbl,resinfo;

	OldREFIndex=SiSREFIndex;         /* push di */
	SiSRVBHRS=50;SiSNewFlickerMode=0;SiSRY1COE=0;
	SiSRY2COE=0;SiSRY3COE=0;SiSRY4COE=0;

	SiSGetResInfo(ROMAddr,ModeNo);
	if (SiSVBInfo&SetCRT2ToRAMDAC) {
		SiSGetRAMDAC2DATA(ROMAddr,ModeNo);
		SiSREFIndex=OldREFIndex;         /* pop di */
		return;
	}
	SiSGetCRT2Ptr(ROMAddr,ModeNo);

	tempal=*((UCHAR *)(ROMAddr+SiSREFIndex));
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex+4));
	tempax=tempal|(((tempah<<8)>>7)&0xFF00);
	SiSRVBHCMAX=tempax;

	tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+1));
	SiSRVBHCFACT=tempal;

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+2));
	SiSVGAHT=(tempax&0x0FFF);

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+3));
	SiSVGAVT=((tempax>>4)&0x07FF);

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+5));
	tempax=(tempax&0x0FFF);
	tempbx=*((USHORT *)(ROMAddr+SiSREFIndex+6));
	tempbx=((tempbx>>4)&0x07FF);
	tempbl=tempbx&0x00FF;

	if (SiSVBInfo&SetCRT2ToTV) {
		tempax=*((USHORT *)(ROMAddr+SiSREFIndex+5));
		tempax=(tempax&0x0FFF);
		SiSHDE=tempax;
		tempax=*((USHORT *)(ROMAddr+SiSREFIndex+6));
		tempax=((tempax>>4)&0x07FF);
		SiSVDE=tempax;
		tempax=*((USHORT *)(ROMAddr+SiSREFIndex+8));
		tempbl=(tempax>>8);
		tempax=tempax&0x0FFF;
		modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
		if (modeflag1&HalfDCLK) {
			tempax=*((USHORT *)(ROMAddr+SiSREFIndex+10));
		}
		SiSRVBHRS=tempax;

		tempbl=tempbl&0x80;
		if (SIS_IF_DEF_HiVision==1) {
			resinfo=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x09)); /* si+Ext_ResInfo */
			if (resinfo==8) tempbl=0x40;
			else if (resinfo==9) tempbl=0x40;
			else if (resinfo==10) tempbl=0x40;
		}

		SiSNewFlickerMode=tempbl;

		if (SIS_IF_DEF_HiVision==1) {
			if (SiSVGAVDE==350) SiSSetFlag=SiSSetFlag|TVSimuMode;
			tempax=ExtHiTVHT;
			tempbx=ExtHiTVVT;
			if (SiSVBInfo&SetInSlaveMode) {
				if (SiSSetFlag&TVSimuMode) {
					tempax=StHiTVHT;
					tempbx=StHiTVVT;
					modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
					if (!(modeflag1&Charx8Dot)) {
						tempax=StHiTextTVHT;
						tempbx=StHiTextTVVT;
					}
				}
			}
    	}
		else {
			tempax=*((USHORT *)(ROMAddr+SiSREFIndex+12));
			SiSRY1COE=(tempax&0x00FF);
			SiSRY2COE=((tempax&0xFF00)>>8);
			tempax=*((USHORT *)(ROMAddr+SiSREFIndex+14));
			SiSRY3COE=(tempax&0x00FF);
			SiSRY4COE=((tempax&0xFF00)>>8);
			if (!(SiSVBInfo&SetPALTV)) {
				tempax=NTSCHT;
				tempbx=NTSCVT;
			} else {
				tempax=PALHT;
				tempbx=PALVT;
			}
    	}
	}
	SiSHT=tempax;
	SiSVT=tempbx;
	if (!(SiSVBInfo&SetCRT2ToLCD)) {
		SiSREFIndex=OldREFIndex;         /* pop di */
		return;
	}

	tempax=1024;
	if (SiSVGAVDE==350) {      /* cx->SiSVGAVDE */
		tempbx=560;
	} else if (SiSVGAVDE==400) {
		tempbx=640;
	} else {
		tempbx=768;
	}

	if (SiSLCDResInfo==Panel1280x1024) {
		tempax=1280;
		if (SiSVGAVDE==360) {
			tempbx=768;
		} else if (SiSVGAVDE==375) {
			tempbx=800;
		} else if (SiSVGAVDE==405) {
			tempbx=864;
		} else {
			tempbx=1024;
		}
	}

	SiSHDE=tempax;
	SiSVDE=tempbx;
	SiSREFIndex=OldREFIndex;         /* pop di */
	return;
}

VOID SiSGetResInfo(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT temp,xres,yres,modeflag1;
	if (ModeNo<=0x13) {
		temp=(USHORT)*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x05));   /* si+St_ResInfo */
		xres=SiSStResInfo[temp][0];
		yres=SiSStResInfo[temp][1];
	} else {
		temp=(USHORT)*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x09));   /* si+Ext_ResInfo */
		xres=SiSModeResInfo[temp][0];  /* xres->ax */
		yres=SiSModeResInfo[temp][1];  /* yres->bx */
		modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));    /* si+St_ModeFlag */
		if (modeflag1&HalfDCLK) { xres=xres*2;}
		if (modeflag1&DoubleScanMode) {yres=yres*2;}
	}
	if (!(SiSLCDResInfo==Panel1024x768)) {
		if (yres==400) yres=405;
		if (yres==350) yres=360;
		if (SiSSetFlag&LCDVESATiming) {
			if (yres==360) yres=375;
		}
	}
	if (SIS_IF_DEF_LVDS==1) {
		if (xres==720) xres=640;
	}
	SiSVGAHDE=xres;
	SiSHDE=xres;
	SiSVGAVDE=yres;
	SiSVDE=yres;
}

VOID SiSGetLVDSDesData(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT old_REFIndex,tempax;

	old_REFIndex=(USHORT)SiSREFIndex; /* push di  */
	SiSREFIndex=SiSGetLVDSDesPtr(ROMAddr,ModeNo);

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex));
	tempax=tempax&0x0FFF;
	SiSLCDHDES=tempax;

	if (SiSLCDInfo&LCDNonExpanding) { /* hw walk-a-round  */
		if (SiSLCDResInfo>=Panel1024x768) {
			if (ModeNo<=0x13) {
				SiSLCDHDES=320;
			}
		}
	}

	tempax=*((USHORT *)(ROMAddr+SiSREFIndex+1));
	tempax=tempax>>4;
	tempax=tempax&0x07FF;
	SiSLCDVDES=tempax;

	SiSREFIndex=old_REFIndex; /* pop di  */
	return;  
}


VOID SiSGetRAMDAC2DATA(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempax,tempbx,tempbh,modeflag1,t1=0,t2;
	SiSRVBHCMAX=1;SiSRVBHCFACT=1;
	if (ModeNo<=0x13) {
		tempax=*((UCHAR *)(ROMAddr+SiSREFIndex+10));
		tempbx=*((USHORT *)(ROMAddr+SiSREFIndex+16));
	} else {
		t1=*((UCHAR *)(ROMAddr+SiSREFIndex+0x2));      /* Ext_CRT1CRTC=2 */
		t1=t1*CRT1Len;
		SiSREFIndex=*((USHORT *)(ROMAddr+0x204));      /* Get SiSCRT1Table */
		SiSREFIndex=SiSREFIndex+t1;
		t1=*((UCHAR *)(ROMAddr+SiSREFIndex+0));
		t2=*((UCHAR *)(ROMAddr+SiSREFIndex+14));
		tempax=(t1&0xFF)|((t2&0x03)<<8);
		tempbx=*((USHORT *)(ROMAddr+SiSREFIndex+6));
		t1=*((UCHAR *)(ROMAddr+SiSREFIndex+13));
		t1=(t1&0x01)<<2;
	}

	tempbh=tempbx>>8;
	tempbh=((tempbh&0x20)>>4)|(tempbh&0x01);
	tempbh=tempbh|t1;
	tempbx=(tempbx&0xFF)|(tempbh<<8);
	tempax=tempax+5;
	modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
	if (modeflag1&Charx8Dot) {
		tempax=tempax*8;
	} else {
		tempax=tempax*9;
	}

	SiSVGAHT=tempax;
	SiSHT=tempax;
	tempbx++;
	SiSVGAVT=tempbx;
	SiSVT=tempbx;
}

VOID SiSGetCRT2Ptr(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempcl,tempbx,tempal,tempax,CRT2PtrData=0;
	USHORT Flag;

	if (SIS_IF_DEF_LVDS==0) {
		if (SiSVBInfo&SetCRT2ToLCD) {              /* LCD */
			tempbx=SiSLCDResInfo;
			tempcl=LCDDataLen;
			tempbx=tempbx-Panel1024x768;
			if (!(SiSSetFlag&LCDVESATiming)) tempbx+=5;  
		}
		else {
			if (SIS_IF_DEF_HiVision==1) {
				if (SiSVGAVDE>480) SiSSetFlag=SiSSetFlag&(!TVSimuMode);
				tempcl=HiTVDataLen;
				tempbx=2;
				if (SiSVBInfo&SetInSlaveMode) {
					if (!(SiSSetFlag&TVSimuMode)) tempbx=10;
				}
			}
			else {
				if (SiSVBInfo&SetPALTV) {
					tempcl=TVDataLen;
					tempbx=3;
				}
				else {
					tempbx=4;
					tempcl=TVDataLen;
				}
			}
		}
		if (SiSSetFlag&TVSimuMode) {
			tempbx=tempbx+4;
		}
		if (ModeNo<=0x13) {
			tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));   /* si+St_CRT2CRTC */
		} else {
			tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+4));    /* di+Ext_CRT2CRTC */
		}
		tempal=tempal&0x1F;

		tempax=tempal*tempcl;
		SiSREFIndex=*((USHORT *)(ROMAddr + 0x20E + tempbx*2));
		SiSREFIndex+=tempax;
	}
	else {   /* LVDS */
		Flag=1;
		tempbx=0;
		if (SIS_IF_DEF_CH7005==1) {
			if (!(SiSVBInfo&SetCRT2ToLCD)) {
				Flag=0;
				tempbx=7;
				if (SiSVBInfo&SetPALTV) tempbx=tempbx+2;
				if (SiSVBInfo&SetCHTVOverScan) tempbx=tempbx+1;
			} 
		}
		tempcl=LVDSDataLen;
		if (Flag==1) {
			tempbx=SiSLCDResInfo-Panel800x600;
			if (SiSLCDInfo&LCDNonExpanding) {
				tempbx=tempbx+3;
			}
		} 
		if (ModeNo<=0x13) tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));      /* si+St_CRT2CRTC */
		else tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x04));      /* di+Ext_CRT2CRTC */
		tempal=tempal&0x1F;
		tempax=tempal*tempcl;
		CRT2PtrData=*((USHORT *)(ROMAddr+ADR_CRT2PtrData)); /* ADR_CRT2PtrData is defined in init.def  */
		SiSREFIndex=*((USHORT *)(ROMAddr+CRT2PtrData+tempbx*2));
		SiSREFIndex+=tempax;
	}
}

VOID SiSUnLockCRT2(USHORT BaseAddr)
{
	UCHAR temp3;
	USHORT  Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	temp3=(UCHAR)SiSGetReg1(Part1Port,0x24);
	temp3=temp3|0x01;
	SiSSetReg1(Part1Port,0x24,(USHORT)temp3);
}

VOID SiSSetCRT2ModeRegs(USHORT BaseAddr,USHORT ModeNo)
{
	USHORT i,j;
	USHORT tempcl,tempah,temp3;
	USHORT  Part4Port;
	USHORT  Part1Port;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	for(i=0,j=4;i<3;i++,j++) {
		SiSSetReg1(Part1Port,j,0);
	}

	tempcl=SiSModeType;
	if (ModeNo>0x13) {
		tempcl=tempcl-ModeVGA;
		if ((tempcl>0)||(tempcl==0)) {
			tempah=((0x010>>tempcl)|0x080);
		}
	} else {
		tempah=0x080;
	}

	if (SiSVBInfo&SetInSlaveMode) {
		tempah=(tempah^0x0A0);
	}
	if (SiSVBInfo&CRT2DisplayFlag) {
		tempah=0;
	}
	SiSSetReg1(Part1Port,0,tempah);


	if (SIS_IF_DEF_LVDS==0) {
		tempah=0x01;
		if (!(SiSVBInfo&SetInSlaveMode)) {
			tempah=(tempah|0x02);
		}
		if (!(SiSVBInfo&SetCRT2ToRAMDAC)) {
			tempah=(tempah^0x05);
			if (!(SiSVBInfo&SetCRT2ToLCD)) {
				tempah=(tempah^0x01);
			}
		}
		tempah=(tempah<<5)&0xFF;
		if (SiSVBInfo&CRT2DisplayFlag) {
			tempah=0;
		}
		SiSSetReg1(Part1Port,0x01,tempah);

		tempah=tempah>>5;
		if ((SiSModeType==ModeVGA)&&(!(SiSVBInfo&SetInSlaveMode))) {
			tempah=tempah|0x010;
		}
		if (SiSLCDResInfo!=Panel1024x768) {
			tempah=tempah|0x080;
		}
		if (SiSVBInfo&SetCRT2ToTV) {
			if (SiSVBInfo&SetInSlaveMode) {
				tempah=tempah|0x020;
			}
		}

		temp3=(UCHAR)SiSGetReg1(Part4Port,0x0D);
		temp3=temp3&(~0x0BF);
		temp3=temp3|tempah;
		SiSSetReg1(Part4Port,0x0D,(USHORT)temp3);

		tempah=0;
		if (SiSVBInfo&SetCRT2ToTV) {
			if (SiSVBInfo&SetInSlaveMode) {
				if (!(SiSSetFlag&TVSimuMode)) {
					if (SIS_IF_DEF_HiVision==0) {
						SiSSetFlag=SiSSetFlag|RPLLDIV2XO;
						tempah=tempah|0x40;
					}
				}
			}
			else {
				SiSSetFlag=SiSSetFlag|RPLLDIV2XO;
				tempah=tempah|0x40;
			}
		}
		if (SiSLCDResInfo==Panel1280x1024) tempah=tempah|0x80;
		if (SiSLCDResInfo==Panel1280x960) tempah=tempah|0x80;
		SiSSetReg1(Part4Port,0x0C,(USHORT)temp3);
	}
	else {
		tempah=0;
		if (!(SiSVBInfo&SetInSlaveMode)) {
			tempah=tempah|0x02;
		}
		tempah=(tempah<<5)&0x0FF;
		if (SiSVBInfo&CRT2DisplayFlag) {
			tempah=0;
		}
		SiSSetReg1(Part1Port,0x01,tempah);
	}
}

VOID SiSSetGroup1(USHORT	BaseAddr,ULONG ROMAddr,USHORT ModeNo,
		PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	if (SIS_IF_DEF_LVDS==0) {	/* 301 */
		SiSSetGroup1_301(BaseAddr,ROMAddr,ModeNo,HwDeviceExtension);
	} else {	/* LVDS */
		SiSSetGroup1_LVDS(BaseAddr,ROMAddr,ModeNo,HwDeviceExtension);
	}
}

VOID SiSSetGroup1_LVDS(USHORT	BaseAddr,ULONG ROMAddr,USHORT ModeNo,
		PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT temp1,temp2,tempcl,tempch,tempbh,tempal,tempah,tempax,tempbx;
	USHORT tempcx,OldREFIndex,lcdhdee;
	USHORT Part1Port;
	USHORT temppush1,temppush2;
	unsigned long int tempeax,tempebx,tempecx,templong;

	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	OldREFIndex=(USHORT)SiSREFIndex;         /* push di  */

	SiSSetCRT2Offset(Part1Port,ROMAddr);
	SiSSetCRT2FIFO(Part1Port,ROMAddr,ModeNo,HwDeviceExtension);
	SiSSetCRT2Sync(BaseAddr,ROMAddr,ModeNo);

	temp1=(SiSVGAHT-1)&0x0FF;            /* BTVGA2HT 0x08,0x09  */
	SiSSetReg1(Part1Port,0x08,temp1);
	temp1=(((SiSVGAHT-1)&0xFF00)>>8)<<4;
	SiSSetRegANDOR(Part1Port,0x09,~0x0F0,temp1);
   
	temp1=(SiSVGAHDE+12)&0x0FF;              /* BTVGA2HDEE 0x0A,0x0C  */
	SiSSetReg1(Part1Port,0x0A,temp1);
	/* temp1=((SiSVGAHDE+12)&0xFF00)>>8;    Wrong              */
	/* SiSSetReg1(Part1Port,0x0C,temp1);  */
  
	temp1=SiSVGAHDE+12;      /* bx  BTVGA@HRS 0x0B,0x0C  */
	temp2=(SiSVGAHT-SiSVGAHDE)>>2;
	temp1=temp1+temp2;
	temp2=(temp2<<1)+temp1;
	tempcl=temp2&0x0FF;

	SiSSetReg1(Part1Port,0x0B,(USHORT)(temp1&0x0FF));
	tempah=(temp1&0xFF00)>>8;
	tempbh=((((SiSVGAHDE+12)&0xFF00)>>8)<<4)&0x0FF;
	tempah=tempah|tempbh;
	SiSSetReg1(Part1Port,0x0C,tempah);
	SiSSetReg1(Part1Port,0x0D,tempcl);       /* BTVGA2HRE 0x0D  */
	tempcx=(SiSVGAVT-1);
	tempah=tempcx&0x0FF;
	if (SIS_IF_DEF_CH7005==1) {
		if (SiSVBInfo&0x0C)
			tempah=tempah-1;
	}
	SiSSetReg1(Part1Port,0x0E,tempah);        /* BTVGA2TV 0x0E,0x12 */
	tempbx=SiSVGAVDE-1;
	tempah=tempbx&0x0FF;
	if (SIS_IF_DEF_CH7005==1) {
		if (SiSVBInfo&0x0C)
			tempah=tempah-1;
	}
	SiSSetReg1(Part1Port,0x0F,tempah);       /* BTVGA2VDEE 0x0F,0x12  */
	tempah=((tempbx&0xFF00)<<3)>>8;
	tempah=tempah|((tempcx&0xFF00)>>8);
	SiSSetReg1(Part1Port,0x12,tempah);
  
	tempbx=(SiSVGAVT+SiSVGAVDE)>>1;             /* BTVGA2VRS     0x10,0x11 */
	tempcx=((SiSVGAVT-SiSVGAVDE)>>4)+tempbx+1;  /* BTVGA2VRE     0x11  */

	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x10,tempah);
	tempbh=(tempbx&0xFF00)>>8;
	tempah=((tempbh<<4)&0x0FF)|(tempcx&0x0F);
	SiSSetReg1(Part1Port,0x11,tempah);

	SiSSetRegANDOR(Part1Port,0x13,~0x03C,tempah);

	/* lines below are newly added for LVDS  */
	tempax=SiSLCDHDES;
	tempbx=SiSHDE;
	tempcx=SiSHT;
	tempcx=tempcx-tempbx; /* SiSHT-SiSHDE  */
	/* push ax       lcdhdes  */
	tempax=tempax+tempbx; /* lcdhdee  */
	tempbx=SiSHT;
	if (tempax>=tempbx) {
		tempax=tempax-tempbx;
	}
	/* push ax   lcdhdee  */
	lcdhdee=tempax;
	tempcx=tempcx>>2;     /* temp  */
	tempcx=tempcx+tempax; /* lcdhrs  */
	if (tempcx>=tempbx) {
		tempcx=tempcx-tempbx;
	}
	/* v ah,cl  */
	tempax=tempcx;
	tempax=tempax>>3; /* BPLHRS */
	tempah=tempax&0x0FF;
	SiSSetReg1(Part1Port,0x14,tempah); /* Part1_14h  */
	tempah=tempah+2;
	tempah=tempah+0x01F;
	tempcl=tempcx&0x0FF;
	tempcl=tempcl&0x07;
	tempcl=(tempcl<<5)&0xFF; /* PHLHSKEW */
	tempah=tempah|tempcl;
	SiSSetReg1(Part1Port,0x15,tempah); /* Part1_15h  */
	tempbx=lcdhdee;       /* lcdhdee  */
	tempcx=SiSLCDHDES;       /* lcdhdes  */
	tempah=(tempcx&0xFF);
	tempah=tempah&0x07;   /* BPLHDESKEW  */
	SiSSetReg1(Part1Port,0x1A,tempah); /* Part1_1Ah  */
	tempcx=tempcx>>3;     /* BPLHDES */
	tempah=(tempcx&0xFF);
	SiSSetReg1(Part1Port,0x16,tempah); /* Part1_16h  */
	tempbx=tempbx>>3;     /* BPLHDEE  */
	tempah=tempbx&0xFF;
	SiSSetReg1(Part1Port,0x17,tempah); /* Part1_17h  */

	tempcx=SiSVGAVT;
	tempbx=SiSVGAVDE;
	tempcx=tempcx-tempbx;         /* GAVT-SiSVGAVDE  */
	tempbx=SiSLCDVDES;               /* VGAVDES  */
	temppush1=tempbx;             /* push bx temppush1 */
	if (SIS_IF_DEF_TRUMPION==0) {
    	if (SIS_IF_DEF_CH7005==1) tempax=SiSVGAVDE;
		if (SiSVBInfo&SetCRT2ToLCD) {
			if (SiSLCDResInfo==Panel800x600) tempax=600;
			else tempax=768;  
		}
	}
	else 
		tempax=SiSVGAVDE;
	tempbx=tempbx+tempax;
	tempax=SiSVT;            /* SiSVT  */
	if (tempbx>=SiSVT) {
		tempbx=tempbx-tempax;
	}
	temppush2=tempbx;     /* push bx  temppush2  */
	tempcx=tempcx>>1;
	tempbx=tempbx+tempcx;
	tempbx++;     /* BPLVRS  */
	if (tempbx>=tempax) {
		tempbx=tempbx-tempax;
	}
	tempah=tempbx&0xFF;
	SiSSetReg1(Part1Port,0x18,tempah); /* Part1_18h  */
	tempcx=tempcx>>3;
	tempcx=tempcx+tempbx;
	tempcx++;             /* BPLVRE  */
	tempah=tempcx&0xFF;
	tempah=tempah&0x0F;
	tempah=tempah|0x030;
	SiSSetRegANDOR(Part1Port,0x19,~0x03F,tempah); /* Part1_19h  */
	tempbh=(tempbx&0xFF00)>>8;
	tempbh=tempbh&0x07;
	tempah=tempbh;
	tempah=(tempah<<3)&0xFF;      /* BPLDESKEW =0 */
	/* movzx  */
	tempbx=SiSVGAVDE;
	if (tempbx!=SiSVDE) {
		tempah=tempah|0x40;
	}
	SiSSetRegANDOR(Part1Port,0x1A,0x07,tempah); /* Part1_1Ah */
	tempecx=SiSVGAVT;
	tempebx=SiSVDE;
	tempeax=SiSVGAVDE;
	tempecx=tempecx-tempeax;      /* SiSVGAVT-SiSVGAVDE  */
	tempeax=tempeax*64;
	templong=tempeax/tempebx;
	if (templong*tempebx<tempeax) {
		templong++;
	}
	tempebx=templong;     /* BPLVCFACT  */
	if (SiSSetFlag&EnableLVDSDDA) {
		tempebx=tempebx&0x03F;
	}
	tempah=(USHORT)(tempebx&0x0FF);
	SiSSetReg1(Part1Port,0x1E,tempah); /* Part1_1Eh */
	tempbx=temppush2;     /*  p bx temppush2 BPLVDEE  */
	tempcx=temppush1;     /* pop cx temppush1 NPLVDES */
	tempbh=(tempbx&0xFF00)>>8;
	tempah=tempah&0x07;
	tempah=tempbh;
	tempah=tempah<<3;
	tempch=(tempcx&0xFF00)>>8;
	tempch=tempch&0x07;
	tempah=tempah|tempch;
	SiSSetReg1(Part1Port,0x1D,tempah); /* Part1_1Dh */
	tempah=tempbx&0xFF;
	SiSSetReg1(Part1Port,0x1C,tempah); /* Part1_1Ch  */
	tempah=tempcx&0xFF;
	SiSSetReg1(Part1Port,0x1B,tempah); /* Part1_1Bh  */
  
	tempecx=SiSVGAHDE;
	tempebx=SiSHDE;
	tempeax=tempecx;
	tempeax=tempeax<<6;
	tempeax=tempeax<<10;
	tempeax=tempeax/tempebx;
	if (tempebx==tempecx) {
		tempeax=65535;
	}
	tempecx=tempeax;
	tempeax=SiSVGAHT;
	tempeax=tempeax<<6;
	tempeax=tempeax<<10;
	tempeax=tempeax/tempecx;
	tempecx=tempecx<<16;
	tempeax=tempeax-1;
	tempax=(USHORT)(tempeax&0x00FFFF);
	tempcx=tempax;
	tempah=tempcx&0x0FF;
	SiSSetReg1(Part1Port,0x1F,tempah); /* Part1_1Fh  */
	tempbx=SiSVDE;
	tempbx--;             /* BENPLACCEND */
	if (SiSSetFlag&EnableLVDSDDA) {
		tempbx=1;
	}
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<3)&0xFF;
	tempch=(tempcx&0xFF00)>>8;
	tempch=tempch&0x07;
	tempah=tempah|tempch;
	SiSSetReg1(Part1Port,0x20,tempah); /* Part1_20h */
	tempah=tempbx&0xFF;
	SiSSetReg1(Part1Port,0x21,tempah); /* Part1_21h */
	tempecx=tempecx>>16;          /* BPLHCFACT  */
	temp1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /*  si+St_ModeFlag  */
	if (temp1&HalfDCLK) {
		tempecx=tempecx>>1;
	}
	tempcx=(USHORT)(tempecx&0x0FFFF);
	tempah=(tempcx&0xFF00)>>8;
	SiSSetReg1(Part1Port,0x22,tempah); /* Part1_22h */
	tempah=tempcx&0x0FF;
	SiSSetReg1(Part1Port,0x23,tempah); /* Part1_23h */
	if (SIS_IF_DEF_TRUMPION==1) {
		tempal=(USHORT)*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x05));   /* si+St_ResInfo */
		if (ModeNo>0x13) {
			SiSSetFlag=SiSSetFlag|ProgrammingCRT2;
			SiSGetRatePtrCRT2(ROMAddr,ModeNo);
			tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x04));      /* di+Ext_CRT2CRTC */
			tempal=tempal&0x1F;
		}
		tempah=0x80;
		tempal=tempal*tempah;
		SiSREFIndex= offset_Zurac; /* offset Zurac need added in rompost.asm  */
		SiSREFIndex=SiSREFIndex+tempal;
		SiSSetTPData();   /* this function not implemented yet  */
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
		SiSSetTPData();
	}
 
	SiSREFIndex=OldREFIndex;         /* pop di  */

	return;
}

VOID SiSSetTPData()
{
	return;
}


VOID SiSSetGroup1_301(USHORT	BaseAddr,ULONG ROMAddr,USHORT ModeNo,
		PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT  temp1,temp2,tempcl,tempch,tempbl,tempbh,tempal,tempah,tempax,tempbx;
	USHORT  tempcx,OldREFIndex;
	USHORT  Part1Port,resinfo,modeflag;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	OldREFIndex=SiSREFIndex;         /* di */

	SiSSetCRT2Offset(Part1Port,ROMAddr);
	SiSSetCRT2FIFO(Part1Port,ROMAddr,ModeNo,HwDeviceExtension);
	SiSSetCRT2Sync(BaseAddr,ROMAddr,ModeNo);

	SiSGetCRT1Ptr(ROMAddr);

	temp1=(SiSVGAHT-1)&0x0FF;            /* BTVGA2HT 0x08,0x09 */
	SiSSetReg1(Part1Port,0x08,temp1);
	temp1=(((SiSVGAHT-1)&0xFF00)>>8)<<4;
	SiSSetRegANDOR(Part1Port,0x09,~0x0F0,temp1);

	temp1=(SiSVGAHDE+12)&0x0FF;              /* BTVGA2HDEE 0x0A,0x0C */
	SiSSetReg1(Part1Port,0x0A,temp1);

	temp1=SiSVGAHDE+12;      /* bx  BTVGA@HRS 0x0B,0x0C */
	temp2=(SiSVGAHT-SiSVGAHDE)>>2;      /* cx */
	temp1=temp1+temp2;
	temp2=(temp2<<1)+temp1;
	tempcl=temp2&0x0FF;
	if (SiSVBInfo&SetCRT2ToRAMDAC) {
		tempbl=*((UCHAR *)(ROMAddr+SiSREFIndex+4));    /* di+4      */
		tempbh=*((UCHAR *)(ROMAddr+SiSREFIndex+14));   /* di+14     */
		temp1=((tempbh>>6)<<8)|tempbl;              /* temp1->bx */
		temp1=(temp1-1)<<3;
		tempcl=*((UCHAR *)(ROMAddr+SiSREFIndex+5));    /* di+5  */
		tempch=*((UCHAR *)(ROMAddr+SiSREFIndex+15));   /* di+15 */
		tempcl=tempcl&0x01F;
		tempch=(tempch&0x04)<<(6-2);
		tempcl=((tempcl|tempch)-1)<<3;
	}
	SiSSetReg1(Part1Port,0x0B,(USHORT)(temp1&0x0FF));
	tempah=(temp1&0xFF00)>>8;
	tempbh=((((SiSVGAHDE+12)&0xFF00)>>8)<<4)&0x0FF;
	tempah=tempah|tempbh;
	SiSSetReg1(Part1Port,0x0C,tempah);
	SiSSetReg1(Part1Port,0x0D,tempcl);       /* BTVGA2HRE 0x0D */
	tempcx=(SiSVGAVT-1);
	tempah=tempcx&0x0FF;
	SiSSetReg1(Part1Port,0x0E,tempah);       /* BTVGA2TV 0x0E,0x12 */
	tempbx=SiSVGAVDE-1;
	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x0F,tempah);       /* BTVGA2VDEE 0x0F,0x12 */
	tempah=((tempbx&0xFF00)<<3)>>8;
	tempah=tempah|((tempcx&0xFF00)>>8);
	SiSSetReg1(Part1Port,0x12,tempah);

	tempbx=(SiSVGAVT+SiSVGAVDE)>>1;             /* BTVGA2VRS     0x10,0x11 */
	tempcx=((SiSVGAVT-SiSVGAVDE)>>4)+tempbx+1;  /* BTVGA2VRE     0x11      */
	if (SiSVBInfo&SetCRT2ToRAMDAC) {
		tempbx=*((UCHAR *)(ROMAddr+SiSREFIndex+8));   /* di+8 */
		temp1=*((UCHAR *)(ROMAddr+SiSREFIndex+7));    /* di+7 */
		if (temp1&0x04) {
			tempbx=tempbx|0x0100;
		}
		if (temp1&0x080) {
			tempbx=tempbx|0x0200;
		}
		temp1=*((UCHAR *)(ROMAddr+SiSREFIndex+13));    /* di+13 */
		if (temp1&0x08) {
			tempbx=tempbx|0x0400;
		}
		tempcl= *((UCHAR *)(ROMAddr+SiSREFIndex+9));   /* di+9 */
		tempcx=(tempcx&0xFF00)|(tempcl&0x00FF);
	}
	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x10,tempah);
	tempbh=(tempbx&0xFF00)>>8;
	tempah=((tempbh<<4)&0x0FF)|(tempcx&0x0F);
	SiSSetReg1(Part1Port,0x11,tempah);

	if (HwDeviceExtension->jChipID == SIS_Glamour) {
		tempah=0x10;
		if ((SiSLCDResInfo!=Panel1024x768)&&(SiSLCDResInfo==Panel1280x1024)) tempah=0x20;
	}
	else 
		tempah=0x20;
	if (SiSVBInfo&SetCRT2ToTV) tempah=0x08;
	if (SIS_IF_DEF_HiVision==1) {
		if (SiSVBInfo&SetInSlaveMode) tempah=0x2c;
		else tempah=0x20;
	}
	SiSSetRegANDOR(Part1Port,0x13,~0x03C,tempah);

	if (!(SiSVBInfo&SetInSlaveMode)) {
		SiSREFIndex=OldREFIndex;
		return;
	}
	if (SiSVBInfo&SetCRT2ToTV) {
		tempax=0xFFFF;
	} else {
		tempax=SiSGetVGAHT2();
	}
	tempcl=0x08;                  /* Reg 0x03 Horozontal Total */
	temp1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
	if (!(temp1&Charx8Dot)) {                           /* temp1->St_ModeFlag */
		tempcl=0x09;
	}
	if (tempax>=SiSVGAHT) {
		tempax=SiSVGAHT;
	}
	if (temp1&HalfDCLK) {
		tempax=tempax>>1;
	}
	tempax=(tempax/tempcl)-5;
	tempbl=tempax;
	tempah=0xFF;          /* set MAX SiSHT */
	SiSSetReg1(Part1Port,0x03,tempah);

	tempax=SiSVGAHDE;                /* 0x04 Horizontal Display End */
	if (temp1&HalfDCLK) {
		tempax=tempax>>1;
	}
	tempax=(tempax/tempcl)-1;
	tempbh=tempax;
	SiSSetReg1(Part1Port,0x04,tempax);

	tempah=tempbh;
	if (SiSVBInfo&SetCRT2ToTV) {
		tempah=tempah+2;
	}
	if (SIS_IF_DEF_HiVision==1) {
		resinfo=*(USHORT *)(ROMAddr+SiSModeIDOffset+0x09); /* si+Ext_ResInfo */
		if (resinfo==7) tempah=tempah-2;
	}
	SiSSetReg1(Part1Port,0x05,tempah); /* 0x05 Horizontal Display Start */
	SiSSetReg1(Part1Port,0x06,0x03);   /* 0x06 Horizontal Blank end     */
                                    /* 0x07 horizontal Retrace Start */
	if (SIS_IF_DEF_HiVision==1) {
		tempah=tempbl-1;
		modeflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
		if (!(modeflag&HalfDCLK)) {
			tempah=tempah-6;
			if (SiSSetFlag&TVSimuMode) {
				tempah=tempah-4;
				if (ModeNo>0x13) tempah=tempah-10;
			}
		}
	}
	else {
		tempcx=(tempbl+tempbh)>>1;
		tempah=(tempcx&0xFF)+2;
		
		if (SiSVBInfo&SetCRT2ToTV) {
			tempah=tempah-1;
			if (!(temp1&HalfDCLK)) {
				if ((temp1&Charx8Dot)) {
					tempah=tempah+4;
					if (SiSVGAHDE>=800) {
						tempah=tempah-6;
					}
				}
			}
		} else {
			if (!(temp1&HalfDCLK)) {
				tempah=tempah-4;
				if (SiSVGAHDE>=800) {
					tempah=tempah-7;
					if (SiSModeType==ModeEGA) {
						if (SiSVGAVDE==1024) {
							tempah=tempah+15;
							if (SiSLCDResInfo!=Panel1280x1024) {
								tempah=tempah+7;
							}
						}
					}
					if (SiSVGAHDE>=1280) {
						tempah=tempah+28;
					}
				}
			}
		}
	}
	SiSSetReg1(Part1Port,0x07,tempah); /* 0x07 Horizontal Retrace Start */

	SiSSetReg1(Part1Port,0x08,0);      /* 0x08 Horizontal Retrace End   */
	SiSSetReg1(Part1Port,0x18,0x03);   /* 0x18 SR08                     */
	SiSSetReg1(Part1Port,0x19,0);      /* 0x19 SR0C                     */
	SiSSetReg1(Part1Port,0x09,0xFF);   /* 0x09 Set Max SiSVT               */

	tempcx=0x121;
	tempcl=0x21;
	tempch=0x01;
	tempbx=SiSVGAVDE;                /* 0x0E Virtical Display End */
	if (tempbx==360) tempbx=350;
	if (tempbx==375) tempbx=350;
	if (tempbx==405) tempbx=400;
	tempbx--;
	tempah=tempbx&0x0FF;
	SiSSetReg1(Part1Port,0x0E,tempah);
	SiSSetReg1(Part1Port,0x10,tempah); /* 0x10 vertical Blank Start */
	tempbh=(tempbx&0xFF00)>>8;
	if (tempbh&0x01) {
		tempcl=tempcl|0x0A;
	}
	tempah=0;tempal=0x0B;
	if (temp1&DoubleScanMode) {
		tempah=tempah|0x080;
	}
	if (tempbh&0x02) {
		tempcl=tempcl|0x040;
		tempah=tempah|0x020;
	}
	SiSSetReg1(Part1Port,0x0B,tempah);
	if (tempbh&0x04) {
		tempch=tempch|0x06;
	}

	SiSSetReg1(Part1Port,0x11,0);  /* 0x11 Vertival Blank End */

	tempax=SiSVGAVT-tempbx;          /* 0x0C Vertical Retrace Start */
	tempax=tempax>>2;
	temp2=tempax;         /* push ax */
	tempax=tempax<<1;
	tempbx=tempax+tempbx;
	if ((SiSSetFlag&TVSimuMode)&&(SiSVBInfo&SetPALTV)&&(SiSVGAHDE==800)) {
		tempbx=tempbx+40;
	}
	tempah=(tempbx&0x0FF);
	SiSSetReg1(Part1Port,0x0C,tempah);
	tempbh=(tempbx&0xFF00)>>8;
	if (tempbh&0x01) {
		tempcl=tempcl|0x04;
	}
	if (tempbh&0x02) {
		tempcl=tempcl|0x080;
	}
	if (tempbh&0x04) {
		tempch=tempch|0x08;
	}

	tempax=temp2;         /* pop ax */
	tempax=(tempax>>2)+1;
	tempbx=tempbx+tempax;
	tempah=(tempbx&0x0FF)&0x0F;
	SiSSetReg1(Part1Port,0x0D,tempah);  /* 0x0D vertical Retrace End */
	tempbl=tempbx&0x0FF;
	if (tempbl&0x10) {
		tempch=tempch|0x020;
	}

	tempah=tempcl;
	SiSSetReg1(Part1Port,0x0A,tempah); /* 0x0A CR07 */
	tempah=tempch;
	SiSSetReg1(Part1Port,0x17,tempah); /* 0x17 SR0A */
	tempax=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
	tempah=(tempax&0xFF00)>>8;
	tempah=(tempah>>1)&0x09;
	SiSSetReg1(Part1Port,0x16,tempah); /* 0x16 SR01 */
	SiSSetReg1(Part1Port,0x0F,0);      /* 0x0F CR14 */
	SiSSetReg1(Part1Port,0x12,0);      /* 0x12 CR17 */
	SiSSetReg1(Part1Port,0x1A,0);      /* 0x1A SR0E */
	
	SiSREFIndex=OldREFIndex;           /* pop di */
}

VOID SiSSetCRT2Offset(USHORT Part1Port,ULONG ROMAddr)
{
	USHORT offset;
	if (SiSVBInfo&SetInSlaveMode) {
		return;
	}
	offset=SiSGetOffset(ROMAddr);
	SiSSetReg1(Part1Port,0x07,(USHORT)(offset&0xFF));
	SiSSetReg1(Part1Port,0x09,(USHORT)((offset&0xFF00)>>8));
	SiSSetReg1(Part1Port,0x03,(USHORT)(((offset>>3)&0xFF)+1));
}

USHORT SiSGetOffset(ULONG ROMAddr)
{
	USHORT tempal,temp1,colordepth;
	tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x03));    /* si+Ext_ModeInfo */
	tempal=(tempal>>4)&0xFF;
	SiSScreenOffset=*((USHORT *)(ROMAddr+0x206));         /* Get ScreeOffset table */
	tempal=*((UCHAR *)(ROMAddr+SiSScreenOffset+tempal));  /* get SiSScreenOffset */
	tempal=tempal&0xFF;
	temp1=*((UCHAR *)(ROMAddr+SiSREFIndex));              /* di+Ext_InfoFlag */
	if (temp1&InterlaceMode) {
		tempal=tempal<<1;
	}
	colordepth=SiSGetColorDepth(ROMAddr);
	return(tempal*colordepth);
}

USHORT SiSGetColorDepth(ULONG ROMAddr)
{
	USHORT ColorDepth[6]={1,2,4,4,6,8};
	USHORT temp;
	int temp1;
	temp=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));      /* si+St_ModeFlag */
	temp1=(temp&ModeInfoFlag)-ModeEGA;
	if (temp1<0) temp1=0;
	return(ColorDepth[temp1]);
}

VOID SiSSetCRT2FIFO(USHORT	Part1Port,ULONG ROMAddr,USHORT ModeNo,
			PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT temp,temp1,temp2,temp3,flag;
	USHORT vclk2ptr,latencyindex;
	USHORT oldREFIndex,CRT1ModeNo,oldModeIDOffset;
	long int longtemp;

	USHORT LatencyFactor[48]={ 97, 88, 86, 79, 77, 00,   /* 64  bit    BQ=2 */
				   00, 87, 85, 78, 76, 54,               /* 64  bit    BQ=1 */
				   97, 88, 86, 79, 77, 00,               /* 128 bit    BQ=2 */
				   00, 79, 77, 70, 68, 48,               /* 128 bit    BQ=1 */
				   80, 72, 69, 63, 61, 00,               /* 64  bit    BQ=2 */
				   00, 70, 68, 61, 59, 37,               /* 64  bit    BQ=1 */
				   86, 77, 75, 68, 66, 00,               /* 128 bit    BQ=2 */
				   00, 68, 66, 59, 57, 37};              /* 128 bit    BQ=1 */

	oldREFIndex=SiSREFIndex;         /* push SiSREFIndex(CRT2 now) */
	oldModeIDOffset=SiSModeIDOffset; /* push SiSModeIDOffset       */

	CRT1ModeNo=(UCHAR)SiSGetReg1(SiSP3d4,0x34); /* get CRT1 ModeNo  */
	SiSSearchModeID(ROMAddr,CRT1ModeNo);     /* Get ModeID Table */

	SiSGetRatePtr(ROMAddr,CRT1ModeNo); /* Set SiSREFIndex-> for crt1 refreshrate */
	temp1=SiSGetVCLK(ROMAddr,CRT1ModeNo,HwDeviceExtension);
	temp2=SiSGetColorTh(ROMAddr);
	temp3=SiSGetMCLK(ROMAddr);
	temp=((USHORT)(temp1*temp2)/temp3);   /* temp->bx */
	temp1=(UCHAR)SiSGetReg1(SiSP3c4,0x14);      /* SR_14    */
	temp1=temp1>>6;
	temp1=temp1<<1;
	if (temp1==0) temp1=1;
	temp1=temp1<<2;               /* temp1->ax */

	longtemp=temp1-temp;

	temp2=(USHORT)((28*16)/(int)longtemp);   /* temp2->cx */
	if (!((temp2*(int)longtemp)==(28*16))) temp2++;

	if ( HwDeviceExtension->jChipID == SIS_Glamour ) {
		temp1=SiSCalcDelayVB();
	} else { /* for Trojan and Spartan */
		flag=(UCHAR)SiSGetReg1(SiSP3c4,0x14);   /* SR_14 */
		if (flag&0x80) {
			latencyindex=12;  /* 128 bit */
		} else {
			latencyindex=0;   /* 64 bit */
		}
		flag=SiSGetQueueConfig();
		if (!(flag&0x01)) {
			latencyindex+=24; /* GUI timing =0 */
		}
		if (flag&0x10) {
			latencyindex+=6;  /* BQ =2 */
		}
		latencyindex=latencyindex + (flag>>5);
		temp1= LatencyFactor[latencyindex];
		temp1=temp1+15;
		flag=(UCHAR)SiSGetReg1(SiSP3c4,0x14);   /* SR_14 */
		if (!(flag&0x80)) {
			temp1=temp1+5;    /* 64 bit */
		}
	}

	temp2=temp2+temp1;
	SiSREFIndex=oldREFIndex;         /* pop SiSREFIndex(CRT2) */
	SiSModeIDOffset=oldModeIDOffset; /* pop SiSModeIDOffset */

	vclk2ptr=SiSGetVCLK2Ptr(ROMAddr,ModeNo);
	temp1=*((USHORT *)(ROMAddr+vclk2ptr+(SiSVCLKLen-2)));
	temp3=SiSGetColorTh(ROMAddr);
	longtemp=temp1*temp2*temp3;
	temp3=SiSGetMCLK(ROMAddr);
	temp3=temp3<<4;
	temp2=(int)(longtemp/temp3);
	if ((long int)temp2*(long int)temp3<(long int)longtemp)
	temp2++;                /* temp2->cx */

	temp1=(UCHAR)SiSGetReg1(Part1Port,0x01);         /* part1port index 01 */

	if ( HwDeviceExtension->uRevisionID >= 0x30 ) /* 630s */
		temp1=(temp1&(~0x1F))|0x1b;
	else 
		temp1=(temp1&(~0x1F))|0x16;

	SiSSetReg1(Part1Port,0x01,temp1);

	if (SIS_IF_DEF_HiVision==1) { 
		if (temp2<=10) temp2=10; 
	}
	else { 
		if (temp2<=6) temp2=6; 
	}

	if ( HwDeviceExtension->uRevisionID >= 0x30 ) 
		temp2=0x13;
	else 
		temp2=0x14;

	if (temp2>0x14) temp2=0x14;
	temp1=(UCHAR)SiSGetReg1(Part1Port,0x02);         /* part1port index 02 */
	temp1=(temp1&(~0x1F))|temp2;
	SiSSetReg1(Part1Port,0x02,temp1);
}

USHORT SiSGetVCLK(ULONG ROMAddr,USHORT ModeNo,
			PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT tempptr;
	USHORT temp1;
	tempptr=SiSGetVCLKPtr(ROMAddr,ModeNo);
	temp1=*((USHORT *)(ROMAddr+tempptr+(SiSVCLKLen-2)));
	return temp1;
}

USHORT SiSGetQueueConfig()
{
	USHORT tempal,tempbl;
	ULONG tempeax;

	SiSSetReg4(0xcf8,0x80000050);
	tempeax=SiSGetReg3(0xcfc);
	tempeax=(tempeax>>24)&0x0f;
	tempbl=(USHORT)tempeax;
	tempbl=tempbl<<4;

	SiSSetReg4(0xcf8,0x800000A0);
	tempeax=SiSGetReg3(0xcfc);
	tempeax=(tempeax>>24)&0x0f;
	tempal=(USHORT)tempeax;
	tempbl=tempbl|tempal;

	return(tempbl);
}

USHORT SiSGetVCLKPtr(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempal=0;
	if (SIS_IF_DEF_LVDS==0) {
		tempal=(UCHAR)SiSGetReg2((USHORT)(SiSP3ca+0x02)); /*  Port 3cch */
		tempal=((tempal>>2)&0x03);
		if (ModeNo>0x13) {
			tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));    /* di+Ext_CRTVCLK */
		}
		SiSVCLKLen=SiSGetVCLKLen(ROMAddr);
		tempal=tempal*SiSVCLKLen;
		tempal=tempal+(*((USHORT *)(ROMAddr+0x208)));  /* SiSVCLKData */
		return ((USHORT)tempal);
	} else {
		if (SiSLCDResInfo==Panel800x600) {
			tempal=VCLK40;
		} else if (SiSLCDResInfo==Panel1024x768) {
			tempal=VCLK65;
		}
		SiSVCLKLen=SiSGetVCLKLen(ROMAddr);
		tempal=tempal*SiSVCLKLen;
		tempal=tempal+(*((USHORT *)(ROMAddr+0x208)));
		return((USHORT)tempal);
	}
}

USHORT SiSGetColorTh(ULONG ROMAddr)
{
	USHORT temp;
	temp=SiSGetColorDepth(ROMAddr);
	temp=temp>>1;
	if (temp==0) temp++;
	return temp;
}

USHORT SiSGetMCLK(ULONG ROMAddr)
{
	USHORT tempmclkptr;
	USHORT tempmclk;
	tempmclkptr=SiSGetMCLKPtr(ROMAddr);
	tempmclk=*((USHORT *)(ROMAddr+tempmclkptr+0x03));        /* di+3 */
	return tempmclk;
}

USHORT SiSGetMCLKPtr(ULONG ROMAddr)
{
	USHORT tempdi;
	USHORT tempdramtype,tempax;

	tempdi=*((USHORT *)(ROMAddr+0x20C));        /* SiSMCLKData */
	tempdramtype=SiSGetDRAMType(ROMAddr);
	tempax=5*tempdramtype;
	tempdi=tempdi+tempax;
	return (tempdi);
}

USHORT SiSGetDRAMType(ULONG ROMAddr)
{
	USHORT tsoftsetting,temp3;
	tsoftsetting=*((UCHAR *)(ROMAddr+0x52));
	if (!(tsoftsetting&SoftDramType)) {
		temp3=(UCHAR)SiSGetReg1(SiSP3c4,0x3A);
		tsoftsetting=temp3;
	}
	tsoftsetting=tsoftsetting&0x07;
	return(tsoftsetting);
}

USHORT SiSCalcDelayVB()
{
	USHORT tempal,tempah,temp1,tempbx;
	USHORT ThTiming[8]={1,2,2,3,0,1,1,2};
	USHORT ThLowB[24]={81,4,72,6,88,8,120,12,
		    55,4,54,6,66,8,90,12,
		    42,4,45,6,55,8,75,12};

	tempah=(UCHAR)SiSGetReg1(SiSP3c4,0x18);     /* SR_18 */
	tempah=tempah&0x62;
	tempah=tempah>>1;
	tempal=tempah;
	tempah=tempah>>3;
	tempal=tempal|tempah;
	tempal=tempal&0x07;

	temp1=ThTiming[tempal];       /* temp1->cl */

	tempbx=(UCHAR)SiSGetReg1(SiSP3c4,0x16);     /* SR_16 */
	tempbx=tempbx>>6;
	tempah=(UCHAR)SiSGetReg1(SiSP3c4,0x14);     /* SR_14 */
	tempah=((tempah>>4)&0x0C);
	tempbx=((tempbx|tempah)<<1);

	tempal=ThLowB[tempbx+1]*temp1;
	tempbx=ThLowB[tempbx];
	tempbx=tempal+tempbx;

	return(tempbx);
}

USHORT SiSGetVCLK2Ptr(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempal,tempbx,temp;
	USHORT LCDXlat1VCLK[4]={VCLK65,VCLK65,VCLK65,VCLK65};
	USHORT LCDXlat2VCLK[4]={VCLK108_2,VCLK108_2,VCLK108_2,VCLK108_2};
	USHORT LVDSXlat1VCLK[4]={VCLK40,VCLK40,VCLK40,VCLK40};
	USHORT LVDSXlat2VCLK[4]={VCLK65,VCLK65,VCLK65,VCLK65};
	USHORT LVDSXlat3VCLK[4]={VCLK65,VCLK65,VCLK65,VCLK65};

	if (SIS_IF_DEF_LVDS==0) {
		if (ModeNo<=0x13) {
			tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));  /* si+St_CRT2CRTC */
		} else {
			tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x04));      /* di+Ext_CRT2CRTC */
		}
		tempal=tempal>>6;
		if (SiSLCDResInfo!=Panel1024x768) {
			tempal=LCDXlat2VCLK[tempal];
		} else {
			tempal=LCDXlat1VCLK[tempal];
		}
	
		if (SiSVBInfo&SetCRT2ToLCD) {
			tempal=tempal;
		} else {        /* for TV */
			if (SiSVBInfo&SetCRT2ToTV) {
				if (SIS_IF_DEF_HiVision==1) {
					if (SiSSetFlag&RPLLDIV2XO) tempal=HiTVVCLKDIV2;
					else tempal=HiTVVCLK;
					if (SiSSetFlag&TVSimuMode) {
						temp=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));      /* si+St_ModeFlag */
						if (temp&Charx8Dot) tempal=HiTVSimuVCLK;
						else tempal=HiTVTextVCLK;
					}
				} else {
					if (SiSVBInfo&SetCRT2ToTV) {
						if (SiSSetFlag&RPLLDIV2XO) tempal=TVVCLKDIV2;
						else tempal=TVVCLK;
					} else {
						tempal=(UCHAR)SiSGetReg2((USHORT)(SiSP3ca+0x02));      /*  Port 3cch */
						tempal=((tempal>>2)&0x03);
						if (ModeNo>0x13) tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));    /* di+Ext_CRTVCLK */
					}
				}
			}
		}
	} else {       /*   LVDS  */
		if (ModeNo<=0x13) tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));
		else tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x04));
		if (SIS_IF_DEF_CH7005==1) {
			if (!(SiSVBInfo&SetCRT2ToLCD)) {
				tempal=tempal&0x1f;
				tempbx=0; 
				if (SiSVBInfo&SetPALTV) tempbx=tempbx+2;
				if (SiSVBInfo&SetCHTVOverScan) tempbx=tempbx+1;
				tempbx=tempbx<<1;
				temp=(*((USHORT *)(ROMAddr+ADR_CHTVVCLKPtr)));
				tempbx=(*((USHORT *)(ROMAddr+temp+tempbx)));
				tempal=(*((USHORT *)(ROMAddr+tempbx+tempal)));
				tempal=tempal&0x00FF;
			}
		} else {
			tempal=tempal>>6;
			if (SiSLCDResInfo==Panel800x600) tempal=LVDSXlat1VCLK[tempal];
			else if (SiSLCDResInfo==Panel1024x768) tempal=LVDSXlat2VCLK[tempal];
			else tempal=LVDSXlat3VCLK[tempal];
		}
	}
	SiSVCLKLen=SiSGetVCLKLen(ROMAddr);
	tempal=tempal*SiSVCLKLen;
	tempal=tempal+(*((USHORT *)(ROMAddr+0x208)));      /* SiSVCLKData */
	return ((USHORT)tempal);
}

USHORT SiSGetVCLKLen(ULONG ROMAddr)
{
	USHORT VCLKDataStart,vclklabel,temp;
	VCLKDataStart=*((USHORT *)(ROMAddr+0x208));
	for(temp=0;;temp++) {
		vclklabel=*((USHORT *)(ROMAddr+VCLKDataStart+temp));
		if (vclklabel==VCLKStartFreq) {
			temp=temp+2;
			return(temp);
		}
	}
	return(0);
}


VOID SiSSetCRT2Sync(USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT temp1,tempah=0;
	USHORT temp;
	USHORT  Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	if (SIS_IF_DEF_LVDS==1) {
		if (SiSVBInfo&SetCRT2ToLCD) {
			tempah=SiSLCDInfo;
			if (!(tempah&LCDSync)) {
				temp=*((USHORT *)(ROMAddr+SiSREFIndex));    /*di+Ext_InfoFlag */
				tempah=(temp>>8)&0x0C0;
			} else {
				tempah=tempah&0x0C0;
			}
		}
	} else {
		temp=*((USHORT *)(ROMAddr+SiSREFIndex));    /* di+Ext_InfoFlag */
		tempah=(temp>>8)&0x0C0;
	}
	temp1=(UCHAR)SiSGetReg1(Part1Port,0x19);    /* part1port index 02 */
	temp1=(temp1&(~0x0C0))|tempah;
	SiSSetReg1(Part1Port,0x19,temp1);
}

VOID SiSGetCRT1Ptr(ULONG ROMAddr)
{
	USHORT temprefcrt1;
	USHORT temp;
	temp=*((UCHAR *)(ROMAddr+SiSREFIndex+0x02));    /* di+Ext_CRT1CRTC */
	temp=temp*CRT1Len;
	temprefcrt1=*((USHORT *)(ROMAddr+0x204));    /* Get SiSCRT1Table */
	SiSREFIndex=temprefcrt1+temp;         /* di->SiSCRT1Table+Ext_CRT1CRTC*CRT1Len */
}

USHORT SiSGetVGAHT2()
{
	long int temp1,temp2;
	temp1=(SiSVGAVT-SiSVGAVDE)*SiSRVBHCMAX;
	temp1=temp1&0x0FFFF;
	temp2=(SiSVT-SiSVDE)*SiSRVBHCFACT;
	temp2=temp2&0x0FFFF;
	temp2=temp2*SiSHT;
	temp2=temp2/temp1;
	return((USHORT)temp2);
}

VOID SiSSetGroup2(USHORT	BaseAddr,ULONG ROMAddr)
{
	USHORT tempah,tempbl,tempbh,tempcl,i,j,tempcx,pushcx,tempbx,tempax;
	USHORT tempmodeflag,tempflowflag;
	UCHAR *temp1;
	USHORT *temp2;
	USHORT pushbx;
	USHORT  Part2Port;
	USHORT  modeflag;
	long int longtemp;

	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	tempcx=SiSVBInfo;
	tempah=SiSVBInfo&0x0FF;
	tempbl=SiSVBInfo&0x0FF;
	tempbh=SiSVBInfo&0x0FF;
	tempbx=(tempbl&0xFF)|(tempbh<<8);
	tempbl=tempbl&0x10;
	tempbh=(tempbh&0x04)<<1;
	tempah=(tempah&0x08)>>1;
	tempah=tempah|tempbh;
	tempbl=tempbl>>3;
	tempah=tempah|tempbl;
	tempah=tempah^0x0C;
	
	if (SIS_IF_DEF_HiVision==1) {
		temp1=(UCHAR *)(ROMAddr+0x0F1);     /* PALPhase */
		tempah=tempah^0x01;
		if (SiSVBInfo&SetInSlaveMode) {
			temp2=SiSHiTVSt2Timing;
			if (SiSSetFlag&TVSimuMode) {
				modeflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   
				if (modeflag&Charx8Dot) temp2=SiSHiTVSt1Timing;
				else temp2=SiSHiTVTextTiming;
			}	
		}
		else  temp2=SiSHiTVExtTiming;
	} else {
		if (SiSVBInfo&SetPALTV) {
			temp1=(UCHAR *)(ROMAddr+0x0F1);     /* PALPhase */
			temp2=SiSPALTiming;
		} else {
			tempah=tempah|0x10;
			temp1=(UCHAR *)(ROMAddr+0x0ED);     /* NTSCPhase */
			temp2=SiSNTSCTiming;
		}
	}
	SiSSetReg1(Part2Port,0x0,tempah);
	for(i=0x31;i<=0x34;i++,temp1++) {
		SiSSetReg1(Part2Port,i,*(UCHAR *)temp1);
	}
	for(i=0x01,j=0;i<=0x2D;i++,j++) {
		SiSSetReg1(Part2Port,i,temp2[j]);
	}
	for(i=0x39;i<=0x45;i++,j++) {
		SiSSetReg1(Part2Port,i,temp2[j]);   /* di->temp2[j] */
	}
	
	tempah=SiSGetReg1(Part2Port,0x0A);
	tempah=tempah|SiSNewFlickerMode;
	SiSSetReg1(Part2Port,0x0A,tempah);
	
	SiSSetReg1(Part2Port,0x35,SiSRY1COE);
	SiSSetReg1(Part2Port,0x36,SiSRY2COE);
	SiSSetReg1(Part2Port,0x37,SiSRY3COE);
	SiSSetReg1(Part2Port,0x38,SiSRY4COE);
	
	if (SIS_IF_DEF_HiVision==1) tempax=950;
	else {
		if (SiSVBInfo&SetPALTV) tempax=520;
		else tempax=440;
	}
	if (SiSVDE<=tempax) {
		tempax=tempax-SiSVDE;
		tempax=tempax>>2;
		tempah=(tempax&0xFF00)>>8;
		tempah=tempah+temp2[0];
		SiSSetReg1(Part2Port,0x01,tempah);
		tempah=tempax&0x00FF;
		tempah=tempah+temp2[1];
		SiSSetReg1(Part2Port,0x02,tempah);
	}
	
	tempcx=SiSHT-1;
	tempah=tempcx&0xFF;
	SiSSetReg1(Part2Port,0x1B,tempah);
	tempah=(tempcx&0xFF00)>>8;
	SiSSetRegANDOR(Part2Port,0x1D,~0x0F,(UCHAR)tempah);
	
	tempcx=SiSHT>>1;
	pushcx=tempcx; /* push cx */
	
	tempcx=tempcx+7;
	if (SIS_IF_DEF_HiVision==1) tempcx=tempcx-4;
	tempah=(tempcx&0xFF);
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x22,~0x0F0,tempah);
	
	
	tempbx=temp2[j];
	tempbx=tempbx+tempcx;
	tempah=tempbx&0xFF;
	SiSSetReg1(Part2Port,0x24,tempah);
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x25,~0x0F0,tempah);
	
	tempbx=tempbx+8;
	if (SIS_IF_DEF_HiVision==1) {
		tempbx=tempbx-4;
		tempcx=tempbx;
	}
	tempah=((tempbx&0xFF)<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x29,~0x0F0,tempah);
	
	tempcx=tempcx+temp2[++j];
	tempah=tempcx&0xFF;
	SiSSetReg1(Part2Port,0x27,tempah);
	tempah=(((tempcx&0xFF00)>>8)<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x28,~0x0F0,tempah);
	
	tempcx=tempcx+8;
	if (SIS_IF_DEF_HiVision==1) tempcx=tempcx-4;
	tempah=tempcx&0xFF;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x2A,~0x0F0,tempah);
	
	tempcx=pushcx;  /* pop cx */
	tempcx=tempcx-temp2[++j];
	tempah=tempcx&0xFF;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x2D,~0x0F0,tempah);
	
	tempcx=tempcx-11;
	if (!(SiSVBInfo&SetCRT2ToTV)) {
		tempax=SiSGetVGAHT2();
		tempcx=tempax-1;
	}
	tempah=tempcx&0xFF;
	SiSSetReg1(Part2Port,0x2E,tempah);
	
	tempbx=SiSVDE;
	if (SiSVGAVDE==360) {
		tempbx=746;
	}
	if (SiSVGAVDE==375) {
		tempbx=746;
	}
	if (SiSVGAVDE==405) {
		tempbx=853;
	}
	/* assuming <<ifndef>> HivisionTV */
	if ((SiSVBInfo&SetCRT2ToTV)) {
		tempbx=tempbx>>1;
	}
	
	tempbx=tempbx-2;
	tempah=tempbx&0xFF;
	SiSSetReg1(Part2Port,0x2F,tempah);
	
	tempah=(tempcx&0xFF00)>>8;
	tempbh=(tempbx&0xFF00)>>8;
	tempbh=(tempbh<<6)&0xFF;
	tempah=tempah|tempbh;
	if (SIS_IF_DEF_HiVision==0) {
		tempah=tempah|0x10;
		if (!(SiSVBInfo&SetCRT2ToSVIDEO)) {
			tempah=tempah|0x20;
		}
	}
	SiSSetReg1(Part2Port,0x30,tempah);
	
	tempbh=0;
	tempbx=tempbx&0xFF;
	
	tempmodeflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));      /* si+St_ModeFlag */
	tempflowflag=0;
	if (!(tempmodeflag&HalfDCLK)) {
		tempcx=SiSVGAHDE;
		if (tempcx>=SiSHDE) {
			tempbh=tempbh|0x20;
			tempbx=(tempbh<<8)|(tempbx&0xFF);
			tempah=0;
		}
	}
	tempcx=0x0101;
	if (SIS_IF_DEF_HiVision==1) {
		if (SiSVGAHDE>=1024) {
			tempcx=0x1920;
			if (SiSVGAHDE>=1280) tempcx=0x1420;
		}
	}
	if (!(tempbh&0x20)) {
		if (tempmodeflag&HalfDCLK) {
			tempcl=((tempcx&0xFF)<<1)&0xFF;
			tempcx=(tempcx&0xFF00)|tempcl;
		}
		pushbx=tempbx;
		tempax=SiSVGAHDE;
		tempbx=(tempcx&0xFF00)>>8;
		longtemp=tempax*tempbx;
		tempcx=tempcx&0xFF;
		longtemp=longtemp/tempcx;
		longtemp=longtemp*8*1024;
		tempax=(longtemp)/SiSHDE;
		if (tempax*SiSHDE<longtemp) {
			tempax=tempax+1;
		} else {
			tempax=tempax;
		}
		tempbx=pushbx;
		tempah=((tempax&0xFF00)>>8)&0x01F;
		tempbh=tempbh|tempah;
		tempah=tempax&0xFF;
	}
	
	SiSSetReg1(Part2Port,0x44,tempah);
	tempah=tempbh;
	SiSSetRegANDOR(Part2Port,0x45,~0x03F,tempah);
	
	if (SIS_IF_DEF_HiVision==1) {
		if (!(SiSVBInfo&SetInSlaveMode)) {
			SiSSetReg1(Part2Port,0x0B,0x00);
		}
	}
	
	if (SiSVBInfo&SetCRT2ToTV) {
		return;
	}
	tempah=0x01;
	if (SiSLCDResInfo==Panel1280x1024) {
		if (SiSModeType==ModeEGA) {
			if (SiSVGAHDE>=1024) {
				tempah=0x02;
			}
		}
	}
	SiSSetReg1(Part2Port,0x0B,tempah);
	
	tempbx=SiSHDE-1;         /* RHACTE=SiSHDE-1 */
	tempah=tempbx&0xFF;
	SiSSetReg1(Part2Port,0x2C,tempah);
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x2B,~0x0F0,tempah);
	
	tempbx=SiSVDE-1;         /* RTVACTEO=(SiSVDE-1)&0xFF */
	tempah=tempbx&0xFF;
	SiSSetReg1(Part2Port,0x03,tempah);
	tempah=((tempbx&0xFF00)>>8)&0x07;
	SiSSetRegANDOR(Part2Port,0x0C,~0x07,tempah);
	
	tempcx=SiSVT-1;
	tempah=tempcx&0xFF;   /* RVTVT=SiSVT-1 */
	SiSSetReg1(Part2Port,0x19,tempah);
	tempah=(tempcx&0xFF00)>>8;
	tempah=(tempah<<5)&0xFF;
	if (SiSLCDInfo&LCDRGB18Bit) {
		tempah=tempah|0x10;
	}
	SiSSetReg1(Part2Port,0x1A,tempah);
	
	tempcx++;
	if (SiSLCDResInfo==Panel1024x768) {
		tempbx=768;
	} else {
		tempbx=1024;
	}
	
	if (tempbx==SiSVDE) {
		tempax=1;
	} else {
		tempax=tempbx;
		tempax=(tempax-SiSVDE)>>1;
	}
	tempcx=tempcx-tempax; /* lcdvdes */
	tempbx=tempbx-tempax; /* lcdvdee */
	
	tempah=tempcx&0xFF;   /* RVEQ1EQ=lcdvdes */
	SiSSetReg1(Part2Port,0x05,tempah);
	tempah=tempbx&0xFF;   /* RVEQ2EQ=lcdvdee */
	SiSSetReg1(Part2Port,0x06,tempah);
	
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<3)&0xFF;
	tempah=tempah|((tempcx&0xFF00)>>8);
	SiSSetReg1(Part2Port,0x02,tempah);
	
	tempcx=(SiSVT-SiSVDE)>>4;   /* (SiSVT-SiSVDE)>>4 */
	tempbx=(SiSVT+SiSVDE)>>1;
	tempah=tempbx&0xFF;   /* RTVACTEE=lcdvrs */
	SiSSetReg1(Part2Port,0x04,tempah);
	
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<4)&0xFF;
	tempbx=tempbx+tempcx+1;
	tempbl=(tempbx&0x0F);
	tempah=tempah|tempbl;  /* RTVACTSO=lcdvrs&0x700>>4+lcdvre */
	SiSSetReg1(Part2Port,0x01,tempah);
	
	tempah=SiSGetReg1(Part2Port,0x09);
	tempah=tempah&0xF0;
	SiSSetReg1(Part2Port,0x09,tempah);
	
	tempah=SiSGetReg1(Part2Port,0x0A);
	tempah=tempah&0xF0;
	SiSSetReg1(Part2Port,0x0A,tempah);
	
	tempcx=(SiSHT-SiSHDE)>>2;    /* (SiSHT-SiSHDE)>>2     */
	tempbx=(SiSHDE+7);        /* lcdhdee         */
	tempah=tempbx&0xFF;    /* RHEQPLE=lcdhdee */
	SiSSetReg1(Part2Port,0x23,tempah);
	tempah=(tempbx&0xFF00)>>8;
	SiSSetRegANDOR(Part2Port,0x25,~0x0F,tempah);
	
	SiSSetReg1(Part2Port,0x1F,0x07);  /* RHBLKE=lcdhdes */
	tempah=SiSGetReg1(Part2Port,0x20);
	tempah=tempah&0x0F;
	SiSSetReg1(Part2Port,0x20,tempah);
	
	tempbx=tempbx+tempcx;
	tempah=tempbx&0xFF;            /* RHBURSTS=lcdhrs */
	SiSSetReg1(Part2Port,0x1C,tempah);
	tempah=(tempbx&0xFF00)>>8;
	tempah=(tempah<<4)&0xFF;
	SiSSetRegANDOR(Part2Port,0x1D,~0x0F0,tempah);
	
	tempbx=tempbx+tempcx;
	tempah=tempbx&0xFF;            /* RHSYEXP2S=lcdhre */
	SiSSetReg1(Part2Port,0x21,tempah);
	
	tempah=SiSGetReg1(Part2Port,0x17);
	tempah=tempah&0xFB;
	SiSSetReg1(Part2Port,0x17,tempah);
	
	tempah=SiSGetReg1(Part2Port,0x18);
	tempah=tempah&0xDF;
	SiSSetReg1(Part2Port,0x18,tempah);
	return;
}

VOID SiSSetGroup3(USHORT  BaseAddr,ULONG ROMAddr)
{
	USHORT i;
	USHORT *tempdi;
	USHORT  Part3Port;
	USHORT  modeflag;
	Part3Port=BaseAddr+IND_SIS_CRT2_PORT_12;
	SiSSetReg1(Part3Port,0x00,0x00);
	if (SiSVBInfo&SetPALTV) {
		SiSSetReg1(Part3Port,0x13,0xFA);
		SiSSetReg1(Part3Port,0x14,0xC8);
	} else {
		SiSSetReg1(Part3Port,0x13,0xF6);
		SiSSetReg1(Part3Port,0x14,0xBF);
	}
	if (SIS_IF_DEF_HiVision==1) {
		tempdi=SiSHiTVGroup3Data;
		if (SiSSetFlag&TVSimuMode) {
			tempdi=SiSHiTVGroup3Simu;
			modeflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   
			if (!(modeflag&Charx8Dot)) {
				tempdi=SiSHiTVGroup3Text;
			}
		}
		for(i=0;i<=0x3E;i++) {
			SiSSetReg1(Part3Port,i,tempdi[i]);
		}
	}
	return;
}

VOID SiSSetGroup4(USHORT  BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT  Part4Port;
	USHORT tempax,tempah,tempcx,tempbx,tempbh,tempch,tempmodeflag;
	long int tempebx,tempeax,templong;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	
	tempax=0x0c;
	if (SiSVBInfo&SetCRT2ToTV) {
		if (SiSVBInfo&SetInSlaveMode) {
			if (!(SiSSetFlag&TVSimuMode)) {
				SiSSetFlag=SiSSetFlag|RPLLDIV2XO;
				tempax=tempax|0x04000;
			}
		} else {
			SiSSetFlag=SiSSetFlag|RPLLDIV2XO;
			tempax=tempax|0x04000;
		}
	}
	
	if (SiSLCDResInfo!=Panel1024x768) {
		tempax=tempax|0x08000;
	}
	tempah=(tempax&0xFF00)>>8;
	SiSSetReg1(Part4Port,0x0C,tempah);
	
	tempah=SiSRVBHCFACT;
	SiSSetReg1(Part4Port,0x13,tempah);
	
	tempbx=SiSRVBHCMAX;
	tempah=tempbx&0xFF;
	SiSSetReg1(Part4Port,0x14,tempah);
	tempbh=(((tempbx&0xFF00)>>8)<<7)&0xFF;
	
	tempcx=SiSVGAHT-1;
	tempah=tempcx&0xFF;
	SiSSetReg1(Part4Port,0x16,tempah);
	tempch=(((tempcx&0xFF00)>>8)<<3)&0xFF;
	tempbh=tempbh|tempch;
	
	tempcx=SiSVGAVT-1;
	if (!(SiSVBInfo&SetCRT2ToTV)) {
		tempcx=tempcx-5;
	}
	tempah=tempcx&0xFF;
	SiSSetReg1(Part4Port,0x17,tempah);
	tempbh=tempbh|((tempcx&0xFF00)>>8);
	tempah=tempbh;
	SiSSetReg1(Part4Port,0x15,tempah);
	
	tempcx=SiSVBInfo;
	tempbx=SiSVGAHDE;
	tempmodeflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));      /* si+St_ModeFlag */
	if (tempmodeflag&HalfDCLK) {
		tempbx=tempbx>>1;
	}
	
	if (SIS_IF_DEF_HiVision==1) {
		tempah=0xA0;
		if (tempbx!=1024) {
			tempah=0xC0;
			if (tempbx!=1280) tempah=0;
		}
	} else {
		if (SiSVBInfo&SetCRT2ToLCD) {
			tempah=0;
			if (tempbx>800) {
				tempah=0x60;
			}
		} else {
			tempah=0x080;
		}
	}
	if (SiSLCDResInfo!=Panel1280x1024) {
		tempah=tempah|0x0A;
	}
	
	SiSSetRegANDOR(Part4Port,0x0E,~0xEF,tempah);
	
	tempebx=SiSVDE;
	
	if (SIS_IF_DEF_HiVision==1) {
		if (!(tempah&0xE0)) tempbx=tempbx>>1;
	}
	
	tempcx=SiSRVBHRS;
	tempah=tempcx&0xFF;
	SiSSetReg1(Part4Port,0x18,tempah);
	
	tempeax=SiSVGAVDE;
	tempcx=tempcx|0x04000;
	tempeax=tempeax-tempebx;
	if (tempeax<0) {
		tempcx=tempcx^(0x04000);
		tempeax=SiSVGAVDE;
	}
	
	templong=(tempeax*256*1024)/tempebx;
	if (tempeax*256*1024-templong*tempebx>0) {
		tempebx=templong+1;
	} else {
		tempebx=templong;
	}
	
	
	tempah=tempebx&0xFF;
	SiSSetReg1(Part4Port,0x1B,tempah);
	tempah=(tempebx&0xFF00)>>8;
	SiSSetReg1(Part4Port,0x1A,tempah);
	tempebx=tempebx>>16;
	tempah=tempebx&0xFF;
	tempah=(tempah<<4)&0xFF;
	tempah=tempah|((tempcx&0xFF00)>>8);
	SiSSetReg1(Part4Port,0x19,tempah);
	
	SiSSetCRT2VCLK(BaseAddr,ROMAddr,ModeNo); 
}

VOID SiSSetCRT2VCLK(USHORT BaseAddr,ULONG ROMAddr,USHORT ModeNo)
{
	USHORT vclk2ptr;
	USHORT tempah,temp1;
	USHORT  Part4Port;

	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	vclk2ptr=SiSGetVCLK2Ptr(ROMAddr,ModeNo);
	SiSSetReg1(Part4Port,0x0A,0x01);
	tempah=*((UCHAR *)(ROMAddr+vclk2ptr+0x01));   /* di+1 */
	SiSSetReg1(Part4Port,0x0B,tempah);
	tempah=*((UCHAR *)(ROMAddr+vclk2ptr+0x00));   /* di */
	SiSSetReg1(Part4Port,0x0A,tempah);
	SiSSetReg1(Part4Port,0x12,0x00);
	tempah=0x08;
	if (SiSVBInfo&SetCRT2ToRAMDAC) {
		tempah=tempah|0x020;
	}
	temp1=SiSGetReg1(Part4Port,0x12);
	tempah=tempah|temp1;
	SiSSetReg1(Part4Port,0x12,tempah);
}

VOID SiSSetGroup5(USHORT  BaseAddr,ULONG ROMAddr)
{
	USHORT  Part5Port;
	USHORT Pindex,Pdata;
	Part5Port=BaseAddr+IND_SIS_CRT2_PORT_14+2;
	Pindex=Part5Port;
	Pdata=Part5Port+1;
	if (SiSModeType==ModeVGA) {
		if (!(SiSVBInfo&(SetInSlaveMode|LoadDACFlag|CRT2DisplayFlag))) {
			SiSEnableCRT2();
			SiSLoadDAC2(ROMAddr,Part5Port);
		}
	}
	return;
}

VOID SiSEnableCRT2()
{
	USHORT temp1;
	temp1=SiSGetReg1(SiSP3c4,0x1E);
	temp1=temp1|0x20;
	SiSSetReg1(SiSP3c4,0x1E,temp1);     /* SR 1E */
}

VOID SiSLoadDAC2(ULONG ROMAddr,USHORT Part5Port)
{
	USHORT data,data2;
	USHORT time,i,j,k;
	USHORT m,n,o;
	USHORT si,di,bx,dl;
	USHORT al,ah,dh;
	USHORT *table=0;
	USHORT Pindex,Pdata;
	Pindex=Part5Port;
	Pdata=Part5Port+1;
	data=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));
	data=data&DACInfoFlag;
	time=64;
	if (data==0x00) table=SIS_MDA_DAC;
	if (data==0x08) table=SIS_CGA_DAC;
	if (data==0x10) table=SIS_EGA_DAC;
	if (data==0x18) {
		time=256;
		table=SIS_VGA_DAC;
	}
	if (time==256) j=16;
	else j=time;

	SiSSetReg3(Pindex,0x00);
	
	for(i=0;i<j;i++) {
		data=table[i];
		for(k=0;k<3;k++) {
			data2=0;
			if (data&0x01) data2=0x2A;
			if (data&0x02) data2=data2+0x15;
			SiSSetReg3(Pdata,data2);
			data=data>>2;
		}
	}
	
	if (time==256) {
		for(i=16;i<32;i++) {
			data=table[i];
			for(k=0;k<3;k++) SiSSetReg3(Pdata,data);
		}
		si=32;
		for(m=0;m<9;m++) {
			di=si;
			bx=si+0x04;
			dl=0;
			for(n=0;n<3;n++) {
				for(o=0;o<5;o++) {
					dh=table[si];
					ah=table[di];
					al=table[bx];
					si++;
					SiSWriteDAC2(Pdata,dl,ah,al,dh);
				}         /* for 5 */
				si=si-2;
				for(o=0;o<3;o++) {
					dh=table[bx];
					ah=table[di];
					al=table[si];
					si--;
					SiSWriteDAC2(Pdata,dl,ah,al,dh);
				}         /* for 3 */
				dl++;
			}            /* for 3 */
			si=si+5;
		}               /* for 9 */
	}
}

VOID SiSWriteDAC2(USHORT Pdata,USHORT dl, USHORT ah, USHORT al, USHORT dh)
{
	USHORT temp;
	USHORT bh,bl;

	bh=ah;
	bl=al;
	if (dl!=0) {
		temp=bh;
		bh=dh;
		dh=temp;
		if (dl==1) {
			temp=bl;
			bl=dh;
			dh=temp;
		} else {
			temp=bl;
			bl=bh;
			bh=temp;
		}
	}
	SiSSetReg3(Pdata,(USHORT)dh);
	SiSSetReg3(Pdata,(USHORT)bh);
	SiSSetReg3(Pdata,(USHORT)bl);
}

VOID SiSLockCRT2(USHORT BaseAddr)
{
	USHORT  Part1Port;
	USHORT  Part4Port;
	USHORT temp1;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	temp1=SiSGetReg1(Part1Port,0x24);
	temp1=temp1&0xFE;
	SiSSetReg1(Part1Port,0x24,temp1);
}

VOID SiSSetLockRegs()
{
	USHORT temp1;

	if ((SiSVBInfo&SetInSlaveMode)&&(!(SiSVBInfo&SetCRT2ToRAMDAC))) {
		SiSVBLongWait(); 
		temp1=SiSGetReg1(SiSP3c4,0x32);
		temp1=temp1|0x20;
		SiSSetReg1(SiSP3c4,0x32,temp1);
		SiSVBLongWait(); 
	}
}

VOID SiSEnableBridge(USHORT BaseAddr)
{
	USHORT part2_02,part2_05;
	USHORT Part2Port;
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;

	if (SIS_IF_DEF_LVDS==0) {
	part2_02=(UCHAR)SiSGetReg1(Part2Port,0x02);
	part2_05=(UCHAR)SiSGetReg1(Part2Port,0x05);
	SiSSetReg1(Part2Port,0x02,0x38);
	SiSSetReg1(Part2Port,0x05,0xFF);
	SiSLongWait();
	SiSSetRegANDOR(Part2Port,0x00,~0x0E0,0x020);
	/* SiSWaitVBRetrace(BaseAddr);  */
	SiSSetReg1(Part2Port,0x02,part2_02);
	SiSSetReg1(Part2Port,0x05,part2_05);
	} else {
	SiSEnableCRT2();
	SiSUnLockCRT2(BaseAddr);
	/* SiSSetRegANDOR(Part1Port,0x02,~0x040,0x0);   */    
	}
}

VOID SiSGetVBInfo(USHORT BaseAddr,ULONG ROMAddr)
{
	USHORT flag1,tempbx,tempbl,tempbh,tempah,temp;
	
	SiSSetFlag=0;
	tempbx=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));      /* si+St_ModeFlag */
	tempbl=tempbx&ModeInfoFlag;
	SiSModeType=tempbl;
	tempbx=0;
	flag1=SiSGetReg1(SiSP3c4,0x38);     /* call BridgeisOn */
	if (SIS_IF_DEF_LVDS==0) {          /* for 301 */
		if (!(flag1&0x20)) {
			SiSVBInfo=CRT2DisplayFlag;
			return;
		}
	}
	tempbl=SiSGetReg1(SiSP3d4,0x30);
	tempbh=SiSGetReg1(SiSP3d4,0x31);
	
	tempah=((SetCHTVOverScan>>8)|(SetInSlaveMode>>8)|(DisableCRT2Display>>8));
	tempah=tempah^0xFF; 
	tempbh=tempbh&tempah;   
	if (SIS_IF_DEF_LVDS==1) {  /* for LVDS */
		if (SIS_IF_DEF_CH7005==1) temp=SetCRT2ToLCD|SetCRT2ToTV;
		else temp=SetCRT2ToLCD;
	} else {
		if (SIS_IF_DEF_HiVision==1) temp=0xFC;
		else temp=0x7C;
	}
	if (!(tempbl&temp)) {
		SiSVBInfo=DisableCRT2Display;
		return;
	}
	if (SIS_IF_DEF_LVDS==0) {
		if (tempbl&SetCRT2ToRAMDAC) {
			tempbl=tempbl&(SetCRT2ToRAMDAC|SwitchToCRT2|SetSimuScanMode);
		} else if (tempbl&SetCRT2ToLCD) {
			tempbl=tempbl&(SetCRT2ToLCD|SwitchToCRT2|SetSimuScanMode);
		} else if (tempbl&SetCRT2ToSCART) {
			tempbl=tempbl&(SetCRT2ToSCART|SwitchToCRT2|SetSimuScanMode);
			tempbh=tempbh|(SetPALTV>>8);
		} else if (tempbl&SetCRT2ToHiVisionTV) {
			tempbl=tempbl&(SetCRT2ToHiVisionTV|SwitchToCRT2|SetSimuScanMode);
			tempbh=tempbh|(SetPALTV>>8);
		}
	} else {
		if (SIS_IF_DEF_CH7005==1) {
			if (tempbl&SetCRT2ToTV) 
			tempbl=tempbl&(SetCRT2ToTV|SwitchToCRT2|SetSimuScanMode);
		} 
		if (tempbl&SetCRT2ToLCD) 
		tempbl=tempbl&(SetCRT2ToLCD|SwitchToCRT2|SetSimuScanMode);
	}
	tempah=SiSGetReg1(SiSP3d4,0x31);
	if (tempah&(CRT2DisplayFlag>>8)) {
		if (!(tempbl&(SwitchToCRT2|SetSimuScanMode))) {
			tempbx=SetSimuScanMode|CRT2DisplayFlag;
			tempbh=((tempbx&0xFF00)>>8);
			tempbl=tempbx&0xFF;
		}
	}
	if (!(tempbh&(DriverMode>>8))) {
		tempbl=tempbl|SetSimuScanMode;
	}
	SiSVBInfo=tempbl|(tempbh<<8);
	if (!(SiSVBInfo&SetSimuScanMode)) {
		if (!(SiSVBInfo&SwitchToCRT2)) {
			if (SiSBridgeIsEnable(BaseAddr)) {
				if (SiSBridgeInSlave()) {
					SiSVBInfo=SiSVBInfo|SetSimuScanMode;
				}
			}
		} else {
			flag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));      /* si+St_ModeFlag */
			if (!(flag1&CRT2Mode)) {
				SiSVBInfo=SiSVBInfo|SetSimuScanMode;
			}
		}
	}
	if (!(SiSVBInfo&DisableCRT2Display)) {
		if (SiSVBInfo&DriverMode) {
			if (SiSVBInfo&SetSimuScanMode) {
				flag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
				if (!(flag1&CRT2Mode)) {
					SiSVBInfo=SiSVBInfo|SetInSlaveMode;
				}
			} 
		} else {
			SiSVBInfo=SiSVBInfo|SetSimuScanMode;
			if (SIS_IF_DEF_LVDS==0) {
				if (SiSVBInfo&SetCRT2ToTV) {
					if (!(SiSVBInfo&SetNotSimuMode))  SiSSetFlag=SiSSetFlag|TVSimuMode;
				}
			}
		}
	} 
	if (SIS_IF_DEF_CH7005==1) {
		tempah=SiSGetReg1(SiSP3d4,0x35);
		if (tempah&TVOverScan) SiSVBInfo=SiSVBInfo|SetCHTVOverScan; 
	}
}

BOOLEAN SiSBridgeIsEnable(USHORT BaseAddr)
{
	USHORT flag1;
	USHORT  Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;

	if (SIS_IF_DEF_LVDS==1) {
		return 1;
	}
	flag1=SiSGetReg1(SiSP3c4,0x38);                   /* call BridgeisOn */
	if (!(flag1&0x20)) { return 0;}
	flag1=SiSGetReg1(Part1Port,0x0);
	if (flag1&0x0a0) {
		return 1;
	} else {
		return 0;
	}
}

BOOLEAN SiSBridgeInSlave()
{
	USHORT flag1;
	flag1=SiSGetReg1(SiSP3d4,0x31);
	if (flag1&(SetInSlaveMode>>8)) {
		return 1;
	} else {
		return 0;
	}
}

BOOLEAN SiSGetLCDResInfo(ULONG ROMAddr,USHORT SiSP3d4)
{
	USHORT tempah,tempbh,tempflag;        

	tempah=(UCHAR)SiSGetReg1(SiSP3d4,0x36);
	tempbh=tempah;
	tempah=tempah&0x0F;
/*  if (tempah!=0) tempah--; */
	if (tempah>Panel1280x1024) tempah=0;
	SiSLCDResInfo=tempah;
	tempbh=tempbh>>4;
	SiSLCDTypeInfo=tempbh;

	tempah=(UCHAR)SiSGetReg1(SiSP3d4,0x37);
	SiSLCDInfo=tempah;

	if (SIS_IF_DEF_LVDS==1) {
		tempflag=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));    /* si+St_ModeFlag  */
		if (tempflag&HalfDCLK) {
			if (SIS_IF_DEF_TRUMPION==0) {
				if (!(SiSLCDInfo&LCDNonExpanding)) {
					if (SiSLCDResInfo==Panel1024x768) {
						tempflag=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x09));/* si+Ext_ResInfo*/
						if (tempflag==4) { /* 512x384  */
							SiSSetFlag=SiSSetFlag|EnableLVDSDDA;
						}
					} else {
						if (SiSLCDResInfo==Panel800x600) {
							tempflag=*((UCHAR*)(ROMAddr+SiSModeIDOffset+0x09));/* si+Ext_ResInfo*/
							if (tempflag==3) { /* 400x300  */
								SiSSetFlag=SiSSetFlag|EnableLVDSDDA;
							} 
						}
					}
				} else {
					SiSSetFlag=SiSSetFlag|EnableLVDSDDA;
				}
			} else {
				SiSSetFlag=SiSSetFlag|EnableLVDSDDA;
			}
		}
	}
	
	if (!(SiSVBInfo&SetCRT2ToLCD)) {
		return 1;
	}
	if (!(SiSVBInfo&(SetSimuScanMode|SwitchToCRT2))) {
		return 1;
	}
	if (SiSVBInfo&SetInSlaveMode) {
		if (SiSVBInfo&SetNotSimuMode) {
			SiSSetFlag=SiSSetFlag|LCDVESATiming;
		}
	} else {
		SiSSetFlag=SiSSetFlag|LCDVESATiming;
	}
	return 1;
}

VOID SiSPresetScratchregister(USHORT SiSP3d4,PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	SiSSetReg1(SiSP3d4,0x37,0x00);
}

BOOLEAN SiSGetLCDDDCInfo(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT tempah;
	tempah=(HwDeviceExtension->usLCDType);/*  set in sisv.c */

	if (tempah>0) tempah++; /*  usLCDType:    */

	SiSSetReg1(SiSP3d4,0x36,tempah);  /* cr 36 0:no LCD 1:1024x768 2:1280x1024 */
	if (tempah>0) return 1;
	else return 0;
}

VOID SiSSetTVSystem(PHW_DEVICE_EXTENSION HwDeviceExtension,ULONG ROMAddr)
{
#if 0
	USHORT tempah;
	tempah=SiSGetReg1(SiSP3c4,0x38);           /* SR 38                          */
	tempah=tempah&0x01;                  /* get SR 38 D0 TV Type Selection */
                                       /* 0:NTSC 1:PAL                   */
	SiSSetRegANDOR(SiSP3d4,0x31,~0x01,tempah); /* set CR 31 D0= SR 38 D0         */
	return;
#else
	USHORT tempah,temp;

	if (SIS_IF_DEF_LVDS==0) { /* 301 */
		if (PRIMARY_VGA==1) { /* primary vga */
			if (HwDeviceExtension->jChipID >= SIS_Trojan) {
				tempah=SiSGetReg1(SiSP3c4,0x17);
				if (tempah&ModeSwitchStatus) {
					tempah=SiSGetReg1(SiSP3c4,0x16);
					tempah=tempah&ActivePAL;
					tempah=tempah>>ActivePALShift;
				} else {
					temp=*((UCHAR *)(ROMAddr+SoftSettingAddr));
					if (temp&SoftTVType) {
		 				tempah=*((UCHAR *)(ROMAddr+ModeSettingAddr));
			 		} else {
						tempah=SiSGetReg1(SiSP3c4,0x38);	/* SR 38 */
					}
				}
			} else {
				temp=*((UCHAR *)(ROMAddr+SoftSettingAddr));
				if (temp&SoftTVType) {
					tempah=*((UCHAR *)(ROMAddr+ModeSettingAddr));
				} else {
					tempah=SiSGetReg1(SiSP3c4,0x38);	/* SR 38 */
				}
			}
			tempah=tempah&0x01;		/* get SR 38 D0 TV Type Selection */
									/* 0:NTSC 1:PAL */
			SiSSetRegANDOR(SiSP3d4,0x31,~0x01,tempah);/* set CR 31 D0= SR 38 D0 */
		}
		else { /* Secondary  */
			tempah=SiSGetReg1(SiSP3c4,0x38);	/* SR 38 */
			tempah=tempah&0x01;			/* get SR 38 D0 TV Type Selection */
										/* 0:NTSC 1:PAL */
			SiSSetRegANDOR(SiSP3d4,0x31,~0x01,tempah);/* set CR 31 D0= SR 38 D0 */
		}
		return;
	} else { /* LVDS */
		tempah=SiSGetReg1(SiSP3c4,0x16);	/* SR 16 */
		tempah=tempah&ActiveNonExpanding;
		tempah=tempah>>ActiveNonExpandingShift;
		tempah=tempah&0x01;	
		tempah=tempah<<LCDNonExpandingShift;
		SiSSetRegANDOR(SiSP3d4,0x37,~LCDNonExpanding,tempah);
		return;
	}		
#endif
}

BOOLEAN SiSGetSenseStatus(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT BaseAddr,ULONG ROMAddr)
{
	USHORT flag1,tempbx,tempal,tempah,tempcx,i;	 
	USHORT Part2Port,Part4Port;
	USHORT RGBSenseData,YCSenseData,VideoSenseData;
	USHORT P2reg0,SenseModeNo,OutputSelect;
	Part2Port=BaseAddr+IND_SIS_CRT2_PORT_10;
	Part4Port=BaseAddr+IND_SIS_CRT2_PORT_14;
	RGBSenseData=*((USHORT *)(ROMAddr+0xF8)); /* 0:F8 in rompost.asm */
	YCSenseData=*((USHORT *)(ROMAddr+0xFA)); /* 0:FA in rompost.asm */
	VideoSenseData=*((USHORT *)(ROMAddr+0xFC)); /* 0:FC in rompost.asm */

	if (SIS_IF_DEF_LVDS==1) {
		SiSGetPanelID();
		tempah=LCDSense;
		SiSSetRegANDOR(SiSP3d4,0x32,~0x5F,tempah); /* Set CR 32 */
		return 0;
	}
	 
	flag1=SiSGetReg1(SiSP3c4,0x38);		/* call BridgeisOn */
	if (!(flag1&0x20)) { return 0;}
	P2reg0=SiSGetReg1(Part2Port,0x00); /* save Part2 Reg index 0 */
	
	if (!(SiSBridgeIsEnable(BaseAddr))) {
		SenseModeNo=0x2E;
		SiSModeType=ModeVGA;
		SiSVBInfo=SetCRT2ToRAMDAC;
		SiSSetFlag=0;
		SiSSetCRT2Group(BaseAddr,ROMAddr,SenseModeNo,HwDeviceExtension);
		/* here perform I/O delay ,read SR 05			 */
		for(i=0;i<0x7FFF;i++) {
			flag1=SiSGetReg1(SiSP3c4,0x05);			
		}
	}		
	
	SiSSetReg1(Part2Port,0x00,0x1C);	/* Set part2 index 0= 0x1C */
	tempah=0;
	
	OutputSelect=*((UCHAR *)(ROMAddr+0xFE));	/* OutputSelect 0:FE in Rompost.asm */
	if (OutputSelect&SetSCARTOutput) {
		tempal=SCARTSense;	
	} else {
		tempal=Monitor2Sense;
	}
	tempbx=RGBSenseData;
	tempcx=0x0E08;
	if (SiSSense(Part4Port,tempbx,tempcx)) {
		if (SiSSense(Part4Port,tempbx,tempcx)) {
			tempah=tempah|tempal; 
		}		
	}
	tempbx=YCSenseData;
	tempcx=0x0604;
	if (SiSSense(Part4Port,tempbx,tempcx)) {
		if (SiSSense(Part4Port,tempbx,tempcx)) {
			tempah=tempah|SVIDEOSense;
			/* Skipped lines about HiTVSense, assuming not HiTV	 */
		}
	}

	/* Assuming not HiTV ,below is of ifndef HiVisionTV */
	if (OutputSelect&BoardTVType) {
		tempbx=VideoSenseData;
		tempcx=0x0804;
		if (SiSSense(Part4Port,tempbx,tempcx)) {
			if (SiSSense(Part4Port,tempbx,tempcx)) {
				tempah=tempah|AVIDEOSense;
			}			
		}	
	} else {
		if (!(tempah&SVIDEOSense)) {
			tempbx=VideoSenseData;
			tempcx=0x0804;
			if (SiSSense(Part4Port,tempbx,tempcx)) {
				if (SiSSense(Part4Port,tempbx,tempcx)) {
					tempah=tempah|AVIDEOSense; 
				}		
			}
		}
	}
	/* end of ifndef HivisionTv */
	if (SiSSenseLCD(HwDeviceExtension,Part4Port,ROMAddr)) {
		if (SiSSenseLCD(HwDeviceExtension,Part4Port,ROMAddr)) {
			tempah=tempah|LCDSense;
		}		
	}
	
	tempbx=0; 
	tempcx=0;
	SiSSense(Part4Port,tempbx,tempcx);
	
	SiSSetRegANDOR(SiSP3d4,0x32,~0x5F,tempah); /* Set CR 32 */
	SiSSetReg1(Part2Port,0x00,P2reg0);		/* recover Part2 reg index 0 */
	
	/* here skipped lines about DisableCRT2Display  */
	return 0;	
}

BOOLEAN SiSSense(USHORT Part4Port,USHORT inputbx,USHORT inputcx)
{
	USHORT tempah,tempcl,tempch;
	
	tempah=inputbx&0xFF;
	SiSSetReg1(Part4Port,0x11,tempah);/* Part4 index 11 */
	tempah=(inputbx&0xFF00)>>8;
	tempcl=inputcx&0xFF;
	tempah=tempah|tempcl;
	SiSSetRegANDOR(Part4Port,0x10,~0x1F,tempah);/* Part4 index 10 */
	
	tempch=(inputcx&0xFF00)>>8;
	tempch=tempch&0x7F;
	/* here skipped lines about call Delay */
	tempah=SiSGetReg1(Part4Port,0x03);		/* Part4 index 03 */
	tempah=tempah^(0x0E);
	tempah=tempah&tempch;
	if (tempah>0) return 1;
	else return 0;			
}

BOOLEAN SiSSenseLCD(PHW_DEVICE_EXTENSION HwDeviceExtension,USHORT Part4Port,ULONG ROMAddr)
{
	USHORT SoftSetting;
	USHORT tempah;			
	SoftSetting=*((UCHAR *)(ROMAddr+0x52));/* 0:52 in rompost.asm */
	if (SiSGetLCDDDCInfo(HwDeviceExtension)) {
		return 1;	
	}
	if (SoftSetting&HotPlugFunction) {
		tempah=SiSGetReg1(Part4Port,0x0F);
		tempah=tempah&0x3F;
		SiSSetReg1(Part4Port,0x0F,tempah); /* Part4 index 0F */
		if (SiSSense(Part4Port,0x0,0x9010)) {
			return 1; 
		} else {
			return 0;
		}	
	} else {
		return 0;
	}		
}

VOID SiSSetRegANDOR(USHORT Port,USHORT Index,USHORT DataAND,USHORT DataOR)
{
	USHORT temp1;
	temp1=SiSGetReg1(Port,Index);     /* part1port index 02 */
	temp1=(temp1&(DataAND))|DataOR;
	SiSSetReg1(Port,Index,temp1);
}

BOOLEAN SiSDetectMonitor(PHW_DEVICE_EXTENSION HwDeviceExtension)
{
	USHORT flag1	;
	USHORT DAC_TEST_PARMS[3]={0x0F,0x0F,0x0F};
	USHORT DAC_CLR_PARMS[3]={0x00,0x00,0x00};

	flag1=SiSGetReg1(SiSP3c4,0x38);		/* call BridgeisOn */
	if ((flag1&0x20)) {
		SiSSetReg1(SiSP3d4,0x30,0x41);
	}
	
	SiSSetMode(HwDeviceExtension,0x2E); /* set mode to 0x2E instead of 0x3 */
 
	SiSClearDAC(SiSP3c8);
	SiSClearALLBuffer(HwDeviceExtension);
	
	SiSLongWait();	/* wait vertical retrace */
	SiSLongWait();
	
	flag1=SiSTestMonitorType(DAC_TEST_PARMS[0],DAC_TEST_PARMS[1],
			DAC_TEST_PARMS[2]);
	if (flag1==0) {
		flag1=SiSTestMonitorType(DAC_TEST_PARMS[0],DAC_TEST_PARMS[1],
			DAC_TEST_PARMS[2]);		
	}		
	if (flag1==1) {
		SiSSetRegANDOR(SiSP3d4,0x32,~Monitor1Sense,Monitor1Sense);					 
	} else {
		SiSSetRegANDOR(SiSP3d4,0x32,~Monitor1Sense,0x0);
	}
	SiSTestMonitorType(DAC_CLR_PARMS[0],DAC_CLR_PARMS[1],DAC_CLR_PARMS[2]);
			
	SiSSetReg1(SiSP3d4,0x34,0x4A);	/* Preset default CRT1 ModeNo =0x4A */
								/* which is used in SiSSetCRT2FIFO() */
	return 1;		
}

BOOLEAN SiSTestMonitorType(USHORT d1,USHORT d2,USHORT d3)
{
	USHORT temp;	
	SiSSetReg3(SiSP3c6,0xFF);
	SiSSetReg3(SiSP3c8,0x00);
	SiSSetReg3(SiSP3c9,d1);
	SiSSetReg3(SiSP3c9,d2);
	SiSSetReg3(SiSP3c9,d3);
	SiSWaitDisplay();			/* wait horizontal retrace */
	temp=SiSGetReg2(SiSP3c2);
	if (temp&0x10) return 1;
	else return 0;			
}

VOID SiSWaitDisplay(VOID)
{
	USHORT temp;
 
	for(temp=0;temp==0;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x01;	 
	}
	for(;temp==1;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x01;	 
	}		
}

VOID SiSLongWait()
{
	USHORT temp;

	USHORT i;
	for(i=0; i<0xFFFF; i++) {
		temp=SiSGetReg2(SiSP3da);
		if (!(temp&0x08))	 
			break;
	}
	for(i=0; i<0xFFFF; i++) {
		temp=SiSGetReg2(SiSP3da);
		if ((temp & 0x09) == 9)
			break;
	} 
}

VOID SiSVBLongWait()
{
	USHORT regsr1f,tempah,temp;

	regsr1f=SiSGetReg1(SiSP3c4,0x1F);
	tempah=regsr1f&(~0xC0);
	SiSSetReg1(SiSP3c4,0x1F,tempah);

	for(temp=1;temp>0;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x08;
	}
	for(;temp==0;) {
		temp=SiSGetReg2(SiSP3da);
		temp=temp&0x08;
	}

	SiSSetReg1(SiSP3c4,0x1F,regsr1f);
	return;
}

BOOLEAN SiSWaitVBRetrace(USHORT  BaseAddr)
{
	USHORT temp;
	USHORT Part1Port;
	Part1Port=BaseAddr+IND_SIS_CRT2_PORT_04;
	temp=SiSGetReg1(Part1Port,0x00);
	if (!(temp&0x80)) {
		return 0;
	}
			
	for(temp=0;temp==0;) {
		temp=SiSGetReg1(Part1Port,0x25);
		temp=temp&0x01;
	}
	for(;temp>0;) {
		temp=SiSGetReg1(Part1Port,0x25);
		temp=temp&0x01;
	}
	return 1;
}


BOOLEAN SiSGetPanelID(VOID)
{
	USHORT PanelTypeTable[16]={ 
		SyncPP|Panel800x600|PanelType00,
		SyncPP|Panel1024x768|PanelType01,
		SyncPP|Panel1024x768|PanelType02,
		SyncPP|Panel1024x768|PanelType03,
		SyncPP|Panel1024x768|PanelType04,
		SyncPP|Panel1024x768|PanelType05,
		SyncPP|Panel1024x768|PanelType06,
		SyncPP|Panel1024x768|PanelType07,
		SyncPP|Panel1024x768|PanelType08,
		SyncPP|Panel1024x768|PanelType09,
		SyncPP|Panel800x600|PanelType0A,
		SyncPP|Panel1024x768|PanelType0B,
		SyncPP|Panel1024x768|PanelType0C,
		SyncPP|Panel1024x768|PanelType0D,
		SyncPP|Panel1024x768|PanelType0E,
		SyncPP|Panel1024x768|PanelType0F
	};
	/*  Bit 15 BPLVSPLTY */
	/*  Bit 14 BPLHSPLTY */
	/*  Bit 6-3 Panel Type */
	/*  Bit 2-0 Display Resolution(001:800x600 010:1024x768 011:1280x1024) */
	USHORT tempah,tempbx;
	USHORT return_flag;

	tempah=SiSGetReg1(SiSP3c4,0x18);
	tempbx=tempah&0x0F;
	if (tempah&0x10) {
		return_flag=1;
	} else {
		return_flag=0;
	}

	if (return_flag==0) {
		if (SIS_IF_DEF_LVDS==1) {
			tempbx=0;
			tempah=SiSGetReg1(SiSP3c4,0x38);
			if (tempah&0x40) tempbx=tempbx|0x08;
			if (tempah&0x20) tempbx=tempbx|0x02;
			if (tempah&0x01) tempbx=tempbx|0x01;
			tempah=SiSGetReg1(SiSP3c4,0x39);
			if (tempah&0x80) tempbx=tempbx|0x04;
		} else {
			return 0;
		}
	}

	if (SIS_IF_DEF_TRUMPION==1) {
		tempbx=1;
	}
	tempbx=PanelTypeTable[tempbx]; /* LVDS table entry */
	tempbx=tempbx|(USHORT)(LCDSync<<8);

	tempah=tempbx&0x0FF;
	SiSSetReg1(SiSP3d4,0x36,tempah);
	tempah=(tempbx&0xFF00)>>8;
	SiSSetRegANDOR(SiSP3d4,0x37,~LCDSyncBit,tempah);
	return 1;
}

VOID SiSModCRT1CRTC(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT OldREFIndex,temp,tempah,i,modeflag1;
	USHORT uSRData;
	
	OldREFIndex=(USHORT)SiSREFIndex;
	temp=SiSGetLVDSCRT1Ptr(ROMAddr,ModeNo);
	if (temp==0) {
		SiSREFIndex=OldREFIndex;
		return;
	}
	tempah=(UCHAR)SiSGetReg1(SiSP3d4,0x11);/*unlock cr0-7  */
	tempah=tempah&0x7F;
	SiSSetReg1(SiSP3d4,0x11,tempah);
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
	SiSSetReg1(SiSP3d4,0x0,tempah);
	SiSREFIndex++;
	for(i=0x02;i<=0x05;SiSREFIndex++,i++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3d4,i,tempah); 
	}
	for(i=0x06;i<=0x07;SiSREFIndex++,i++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3d4,i,tempah); 
	}
	for(i=0x10;i<=0x11;SiSREFIndex++,i++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3d4,i,tempah); 
	}
	for(i=0x15;i<=0x16;SiSREFIndex++,i++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3d4,i,tempah); 
	}
	
	for(i=0x0A;i<=0x0C;SiSREFIndex++,i++) {
		tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
		SiSSetReg1(SiSP3c4,i,tempah); 
	}
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
	tempah=tempah&0x0E0;
	uSRData=(UCHAR)SiSGetReg1(SiSP3c4,0x0E);
	uSRData&=0x1F;
	tempah |= uSRData;
	SiSSetReg1(SiSP3c4,0x0E,tempah);
	
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));
	tempah=tempah&0x01;
	tempah=tempah<<5;
	modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag */
	if (modeflag1&DoubleScanMode) {
		tempah=tempah|0x080;
	}
	SiSSetRegANDOR(SiSP3d4,0x09,~0x020,tempah);
	SiSREFIndex=OldREFIndex;
	return; 
}

VOID SiSSetCRT2ECLK(ULONG ROMAddr, USHORT ModeNo)
{
	USHORT OldREFIndex,tempah,tempal;
	USHORT P3cc=SiSP3c9+3;

	OldREFIndex=(USHORT)SiSREFIndex;
	if (SIS_IF_DEF_TRUMPION==0) {  /*no trumpion  */
		tempal=SiSGetReg2(P3cc);
		tempal=tempal&0x0C;
		SiSREFIndex=SiSGetVCLK2Ptr(ROMAddr,ModeNo);
	} else {  /*trumpion  */
		SiSSetFlag=SiSSetFlag&(~ProgrammingCRT2);
		tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+0x03));   /*&di+Ext_CRTVCLK  */
		tempal=tempal&0x03F;
		if (tempal==0x02) { /*31.5MHz  */
			SiSREFIndex=SiSREFIndex-Ext2StructSize;
		}
		SiSREFIndex=SiSGetVCLKPtr(ROMAddr,ModeNo);
		SiSSetFlag=SiSSetFlag|ProgrammingCRT2;
	}
	tempal=0x02B;
	if (!(SiSVBInfo&SetInSlaveMode)) {
		tempal=tempal+3; 
	}
	SiSSetReg1(SiSP3c4,0x05,0x86);
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex));  
	SiSSetReg1(SiSP3c4,tempal,tempah);
	tempah=*((UCHAR *)(ROMAddr+SiSREFIndex+1));
	tempal++; 
	SiSSetReg1(SiSP3c4,tempal,tempah);
	tempal++;
	SiSSetReg1(SiSP3c4,tempal,0x80);
	SiSREFIndex=OldREFIndex;
	return;
}

USHORT SiSGetLVDSDesPtr(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempcl,tempbx,tempal,tempptr,LVDSDesPtrData;
	USHORT Flag;

	Flag=1;
	tempbx=0;
	if (SIS_IF_DEF_CH7005==1) {
		if (!(SiSVBInfo&SetCRT2ToLCD)) {
			Flag=0;
			tempbx=32;
			if (SiSVBInfo&SetPALTV) tempbx=tempbx+2;
			if (SiSVBInfo&SetCHTVOverScan) tempbx=tempbx+1;
		}
	} 
	tempcl=LVDSDesDataLen;
	if (Flag) {
		tempbx=SiSLCDTypeInfo;
		if (SiSLCDInfo&LCDNonExpanding) {
			tempbx=tempbx+16;
		}
	} 
	if (ModeNo<=0x13) tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));   /* si+St_CRT2CRTC  */
	else  tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+4));    /*di+Ext_CRT2CRTC  */
	tempal=tempal&0x1F;
	tempal=tempal*tempcl;
	tempbx=tempbx<<1;
	LVDSDesPtrData=*((USHORT *)(ROMAddr+ADR_LVDSDesPtrData));
	tempptr=*((USHORT *)(ROMAddr+LVDSDesPtrData+tempbx));
	tempptr=tempptr+tempal;
	return(tempptr);
}

BOOLEAN SiSGetLVDSCRT1Ptr(ULONG ROMAddr,USHORT ModeNo)
{
	USHORT tempal,tempbx,modeflag1; 
	USHORT LVDSCRT1DataPtr,Flag; 

	if (!(SiSVBInfo&SetInSlaveMode)) {
	/*       return 0;  */
	}

	Flag=1;
	tempbx=0;
	if (SIS_IF_DEF_CH7005==1) {
		if (!(SiSVBInfo&SetCRT2ToLCD)) {
			Flag=0;
			tempbx=12;
			if (SiSVBInfo&SetPALTV) tempbx=tempbx+2;
			if (SiSVBInfo&SetCHTVOverScan) tempbx=tempbx+1;	
		}
	}
	if (Flag) {
		tempbx=SiSLCDResInfo;
		tempbx=tempbx-Panel800x600;
		if (SiSLCDInfo&LCDNonExpanding) tempbx=tempbx+6;
		modeflag1=*((USHORT *)(ROMAddr+SiSModeIDOffset+0x01));   /* si+St_ModeFlag  */
		if (modeflag1&HalfDCLK) tempbx=tempbx+3;
	}
	if (ModeNo<=0x13) tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));   /* si+St_CRT2CRTC  */
	else tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+4));    /*di+Ext_CRT2CRTC  */
	tempal=tempal&0x3F;

	tempbx=tempbx<<1;

	LVDSCRT1DataPtr=*((USHORT *)(ROMAddr+ADR_LVDSCRT1DataPtr));
	SiSREFIndex=*((USHORT *)(ROMAddr+LVDSCRT1DataPtr+tempbx));
	tempal=tempal*LVDSCRT1Len;
	SiSREFIndex=SiSREFIndex+tempal;
	return 1;
}

VOID SiSSetCHTVReg(ULONG ROMAddr,USHORT ModeNo) 
{
	USHORT old_REFIndex,temp,tempbx,tempcl;
	
	old_REFIndex=(USHORT)SiSREFIndex;                /*push di  */
	SiSGetCHTVRegPtr(ROMAddr,ModeNo);
	
	if (SiSVBInfo&SetPALTV) {
		SiSSetCH7005(0x4304); 
		SiSSetCH7005(0x6909); 
	} 
	else {
		SiSSetCH7005(0x0304); 
		SiSSetCH7005(0x7109); 
	}
	
	temp=*((USHORT *)(ROMAddr+SiSREFIndex+0x00));
	tempbx=((temp&0x00FF)<<8)|0x00;
	SiSSetCH7005(tempbx); 
	temp=*((USHORT *)(ROMAddr+SiSREFIndex+0x01));
	tempbx=((temp&0x00FF)<<8)|0x07;
	SiSSetCH7005(tempbx);	
	temp=*((USHORT *)(ROMAddr+SiSREFIndex+0x02));
	tempbx=((temp&0x00FF)<<8)|0x08;
	SiSSetCH7005(tempbx);	
	temp=*((USHORT *)(ROMAddr+SiSREFIndex+0x03));
	tempbx=((temp&0x00FF)<<8)|0x0A;
	SiSSetCH7005(tempbx);	
	temp=*((USHORT *)(ROMAddr+SiSREFIndex+0x04));
	tempbx=((temp&0x00FF)<<8)|0x0B;
	SiSSetCH7005(tempbx);	
	
	SiSSetCH7005(0x2801);	
	SiSSetCH7005(0x3103);	
	SiSSetCH7005(0x003D);	
	SiSSetCHTVRegANDOR(0x0010,0x1F);	
	SiSSetCHTVRegANDOR(0x0211,0xF8);
	SiSSetCHTVRegANDOR(0x001C,0xEF);
	  
	if (!(SiSVBInfo&SetPALTV)) {
		if (ModeNo<=0x13) tempcl=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));   /* si+St_CRT2CRTC */
		else tempcl=*((UCHAR *)(ROMAddr+SiSREFIndex+4));    /* di+Ext_CRT2CRTC */
		tempcl=tempcl&0x3F;
		if (SiSVBInfo&SetCHTVOverScan) {
			if (tempcl==0x04) {   /* 640x480   underscan */
				SiSSetCHTVRegANDOR(0x0020,0xEF);	
				SiSSetCHTVRegANDOR(0x0121,0xFE);	
			} else { 
				if (tempcl==0x05) {    /* 800x600  underscan */    
					SiSSetCHTVRegANDOR(0x0118,0xF0);	
					SiSSetCHTVRegANDOR(0x0C19,0xF0);	
					SiSSetCHTVRegANDOR(0x001A,0xF0);	
					SiSSetCHTVRegANDOR(0x001B,0xF0);	
					SiSSetCHTVRegANDOR(0x001C,0xF0);	
					SiSSetCHTVRegANDOR(0x001D,0xF0);	
					SiSSetCHTVRegANDOR(0x001E,0xF0);	
					SiSSetCHTVRegANDOR(0x001F,0xF0);	
					SiSSetCHTVRegANDOR(0x0120,0xEF);	
					SiSSetCHTVRegANDOR(0x0021,0xFE);	
				}
			}
		} else {
			if (tempcl==0x04) {     /* 640x480   overscan  */
				SiSSetCHTVRegANDOR(0x0020,0xEF);	
				SiSSetCHTVRegANDOR(0x0121,0xFE);	
			} else {
				if (tempcl==0x05) {   /* 800x600   overscan */
					SiSSetCHTVRegANDOR(0x0118,0xF0);	
					SiSSetCHTVRegANDOR(0x0F19,0xF0);	
					SiSSetCHTVRegANDOR(0x011A,0xF0);	
					SiSSetCHTVRegANDOR(0x0C1B,0xF0);	
					SiSSetCHTVRegANDOR(0x071C,0xF0);	
					SiSSetCHTVRegANDOR(0x011D,0xF0);	
					SiSSetCHTVRegANDOR(0x0C1E,0xF0);	
					SiSSetCHTVRegANDOR(0x071F,0xF0);	
					SiSSetCHTVRegANDOR(0x0120,0xEF);	
					SiSSetCHTVRegANDOR(0x0021,0xFE);	
				}
			}
		}
	}
	
	SiSREFIndex=old_REFIndex;   		
}

VOID SiSSetCHTVRegANDOR(USHORT tempax,USHORT tempbh)
{
	USHORT tempal,tempah,tempbl;

	tempal=tempax&0x00FF;
	tempah=(tempax>>8)&0x00FF;
	tempbl=SiSGetCH7005(tempal); 
	tempbl=(((tempbl&tempbh)|tempah)<<8|tempal);  
	SiSSetCH7005(tempbl);  
}

VOID SiSGetCHTVRegPtr(ULONG ROMAddr,USHORT ModeNo) 
{
	USHORT tempbx,tempal,tempcl,CHTVRegDataPtr;

	if (SiSVBInfo&SetCRT2ToTV) {
		tempbx=0;
		if (SiSVBInfo&SetPALTV) tempbx=tempbx+2;
		if (SiSVBInfo&SetCHTVOverScan) tempbx=tempbx+1;
		
		if (ModeNo<=0x13) tempal=*((UCHAR *)(ROMAddr+SiSModeIDOffset+0x04));   /* si+St_CRT2CRTC */
		else tempal=*((UCHAR *)(ROMAddr+SiSREFIndex+4));    /* di+Ext_CRT2CRTC */
		tempal=tempal&0x3F;
		    
		tempcl=CHTVRegDataLen;
		tempal=tempal*tempcl;
		tempbx=tempbx<<1;
		
		CHTVRegDataPtr=*((USHORT *)(ROMAddr+ADR_CHTVRegDataPtr));
		SiSREFIndex=*((USHORT *)(ROMAddr+CHTVRegDataPtr+tempbx));
		SiSREFIndex=SiSREFIndex+tempal;
	}	 
}

VOID SiSSetCH7005(USHORT tempbx)
{
	USHORT tempah,temp;

	SiSDDC_Port=0x3c4;
	SiSDDC_Index=0x11;
	SiSDDC_DataShift=0x00;
	SiSDDC_DeviceAddr=0xEA;

	SiSSetSwitchDDC2();  
	SiSSetStart();
	tempah=SiSDDC_DeviceAddr;
	temp=SiSWriteDDC2Data(tempah); 
	tempah=tempbx&0x00FF; 
	temp=SiSWriteDDC2Data(tempah);  
	tempah=(tempbx&0xFF00)>>8; 
	temp=SiSWriteDDC2Data(tempah);  
	SiSSetStop();   
}

USHORT SiSGetCH7005(USHORT tempbx)
{
	USHORT tempah;

	SiSDDC_Port=0x3c4;
	SiSDDC_Index=0x11;
	SiSDDC_DataShift=0x00;
	SiSDDC_DeviceAddr=0xEA;
	SiSDDC_ReadAddr=tempbx;

	SiSSetSwitchDDC2();  
	SiSSetStart();
	tempah=SiSDDC_DeviceAddr;
	SiSWriteDDC2Data(tempah);
	tempah=SiSDDC_ReadAddr;
	SiSWriteDDC2Data(tempah);

	SiSSetStart();
	tempah=SiSDDC_DeviceAddr;
	tempah=tempah|0x01;
	if (SiSWriteDDC2Data(tempah)) {
	}
	tempah=SiSReadDDC2Data(tempah);  
	SiSSetStop();   
	return(tempah);
}

VOID SiSSetSwitchDDC2(VOID)
{
	USHORT i;

	SiSSetSCLKHigh();
	for(i=0;i<1000;i++) {
		SiSGetReg1(SiSDDC_Port,0x05);
	}
	SiSSetSCLKLow();
	for(i=0;i<1000;i++) {
		SiSGetReg1(SiSDDC_Port,0x05);
	}
}


VOID SiSSetStart(VOID)
{
	SiSSetSCLKLow();  
	SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFD,0x02);     /*  SetSDA(0x01); */
	SiSSetSCLKHigh();    
	SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFD,0x00);      /* SetSDA(0x00); */
	SiSSetSCLKHigh();    
}

VOID SiSSetStop(VOID)
{
	SiSSetSCLKLow();  
	SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFD,0x00);    /*  SetSDA(0x00); */
	SiSSetSCLKHigh();  
	SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFD,0x02);      /* SetSDA(0x01); */
	SiSSetSCLKHigh();    
}

USHORT SiSWriteDDC2Data(USHORT tempax)
{ 
	USHORT i,flag;

	flag=0x80;
	for(i=0;i<8;i++) {  
		SiSSetSCLKLow();  
		if (tempax&flag) {
			SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFD,0x02);     
		} else {
			SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFD,0x00);     
		}
		SiSSetSCLKHigh();    
		flag=flag>>1;
	}
	return(SiSCheckACK());
}

USHORT SiSReadDDC2Data(USHORT tempax)
{ 
	USHORT i,temp,getdata;

	getdata=0;
	for(i=0;i<8;i++) {  
		getdata=getdata<<1;
		SiSSetSCLKLow();
		SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFD,0x02);      
		SiSSetSCLKHigh();
		temp=SiSGetReg1(SiSDDC_Port,SiSDDC_Index);      	
		if (temp&0x02) getdata=getdata|0x01;
	}  
	return(getdata);
}  

VOID SiSSetSCLKLow(VOID)
{
	SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFE,0x00);      /* SiSSetSCLKLow()  */
	SiSDDC2Delay(); 
}


VOID SiSSetSCLKHigh(VOID)
{
	USHORT temp;
	
	SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFE,0x01);      /* SiSSetSCLKLow()  */
	do {
		temp=SiSGetReg1(SiSDDC_Port,SiSDDC_Index);
	} while(!(temp&0x01));
	SiSDDC2Delay(); 
}  

VOID SiSDDC2Delay(VOID)
{
	USHORT i;

	for(i=0;i<DDC2DelayTime;i++) {   
		SiSGetReg1(SiSP3c4,0x05); 	
	}
}

USHORT SiSCheckACK(VOID)
{
	USHORT tempah;

	SiSSetSCLKLow();
	SiSSetRegANDOR(SiSDDC_Port,SiSDDC_Index,0xFD,0x02);  
	SiSSetSCLKHigh();
	tempah=SiSGetReg1(SiSDDC_Port,SiSDDC_Index);
	SiSSetSCLKLow();
	if (tempah&0x01) return(1);
	else return(0);
}





